COMMENT
COMMENT

SET SAFETY OFF
SET ECHO NONE

COMMENT
*************************************** DANISH **************************************************
******************************** GENEREL INFORMATION OM SCRIPTET ********************************
Navn:         W55_UDT_EXT_VIEW_FILTER 
*
Beskrivelse:  Scriptet gemmer det brugerens view i en ny tabel.
*
Forml:       At gemme view i en ny tabel. Svarende til den mulighed der er i kommandoen EXPORT.
*
Forudstning: Der er en tabel ben.
*
Input:        Skrmdialog: Tabelnavn til resultat
*
Output:       Ny tabel med filtreret records og felter fra brugerens view
*
*
Applications: Vrktjskasse \ Udtrk af data \ Extract view
*
*
 Dato:          Udviklet:  2012-11-15
                Opdateret: 2012-11-16 
*
 Version:       1.0
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
*
*************************************** ENGLISH **************************************************
******************************** GENEREL INFORMATION OM SCRIPTET ********************************
Name:           EXTRACT_VIEW_FILTER 
*
Description:    The script extract the content of the users view with a filter.
*
Purpose:        To save the view in a new table (like EXPORT view).
*
Preconditions:  Der er en tabel ben.
*
Input:          Screen dialog: Tablename to the result (new table)
*
Output:         New table with filtred records and fields from view.
*
*
Applications:   Only used in Denmark.
*
*
 Dato:          Udviklet:  2012-11-15
                Opdateret: 2012-11-16 
*
 Version:       1.0
*
 Developed by:  Erling T Petersen, SKAT Denmark, Erling.Petersen@skat.dk
*
 Copyright:     The script is made to help auditors/ACL users in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
END

COMMENT
******************************** Description of variables ***************************************
v_tabelnavn:    New table name - input from user               
END

COMMENT ********************* SCRIPT START *****************************************
SAVE
DELETE SCRIPT e_audit_EXTRACT_VIEW_FILTER OK

COMMENT -------------------------- Language - Begin ------------------------------------------

COMMENT ----- v_default_language og v_valid_characters ------
DO SCRIPT Func_v_GetLanguage


COMMENT ----- EN ----- English ----- Begin ---

IF v_default_language='EN' v_dialogbox_name    ='SAVE VIEW'
IF v_default_language='EN' v_dialog_text_01    ='Write a new table name:'

COMMENT ----- EN ----- English ----- End -----
COMMENT ----- EN ----- Danish ----- Begin ---

IF v_default_language='DA' v_dialogbox_name    ='GEM VIEW'
IF v_default_language='DA' v_dialog_text_01    ='Indtast et nyt tabelnavn:'

COMMENT ----- EN ----- Danish ----- End -----



DIALOG (DIALOG TITLE "%v_dialogbox_name%" WIDTH 580 HEIGHT 100 ) (BUTTONSET TITLE "&OK;&Cancel" AT 480 12 DEFAULT 1 ) (TEXT TITLE "%v_dialog_text_01%" AT 12 16 ) (EDIT TO "v_tabelnavn" AT 180 12 WIDTH 279 )

DO e_audit_GetACLandTableInfo

v_tabelnavn=ALLTRIM(REPLACE(INCLUDE(v_tabelnavn '%v_valid_characters%') ' ' '_'))

v_view_fields=REPLACE(v_GetOpenViewFieldName '#' ' ')
SET FILTER %v_GetViewFilter%

EXTRACT FIELDS %v_view_fields% TO "%v_tabelnavn%" OPEN

COMMENT ************************* SLETNING AF LOKALE VARIABLER *********************
DELETE v_dialogbox_name OK
DELETE v_dialog_text_01 OK
DELETE v_tabelnavn OK
DELETE v_view_fields OK
DO e_audit_DEL_GetACLandTableInfo


SET ECHO ON
