*********** ENGLISH ********************* GENEREL INFORMATION ABOUT THE SCRIPT ********************************
* 
COMMENT
COMMENT
COMMENT 
*********** ENGLISH ********************* GENEREL INFORMATION ABOUT THE SCRIPT ********************************
* 
 Description:   The script extract pattern to a new table.
                The script use the function MAP() or find minimum and maximum number of characters in a field.
*
 Version:       ACL version 9.2.1.
*
 Purpose:       The purpose of the script is:
                - find pattern in a field.
*
 Preconditions: English version of ACL.
*
 Input:         Screen dialog.
                - MAP + pattern or minimum and maximum (all characters or only digits).
                - new fieldname and tablename.
*
 Output:        New table with default view and pattern view.
*
*
 Date:          Developed: 2011-09-10
                Updated  : 2011-09-10 Version 1.0
*
 Version:       1.0
*
 Developer:     Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:     The script is made to help script developers in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
END


COMMENT 
*********** DANISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
 Beskrivelse:   Scriptet laver extract af et mnster til en ny tabel.
*
 Version:       ACL version 9.2.1
*
 Forml:        Forml med scriptet er:
                - at finde et mnster i en tekst.
*
 Forudstning:  Engelske version af ACL.
*
 Input:         Skrmdialog.
                - Funktionen MAP + mnster eller minimum og maksimum (alle karakterer eller kun cifre)
                - nyt feltnavn og tabelnavn
*
 Output:        Ny tabel med default view og mnster view.
*
*
 Applications:  Scriptet er placeret under 10 DIVERSE.
*
 Dato:          Udviklet:  2011-09-10
                Opdateret: 2011-09-10 Version 1.0
*
 Version:       1.0
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055. Email: erling.petersen@skat.dk
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
END


COMMENT *************************** SCRIPT START ************************************************


SET ECHO NONE
SET SAFETY OFF

DELETE SCRIPT e_audit_FIND_PATTERN OK

DO SCRIPT e_audit_DEL_GetACLandTableInfo
DO SCRIPT e_audit_GetACLandTableInfo
IF v_GetUserSetExactOnOff='ON' SET EXACT OFF

OPEN "%v_GetOpenTableName%"

COMMENT --- Begin ---------- DELETE VARIABLES - sub script -------------------------------------
EXPORT "DELETE SCRIPT w55_sub_del_var OK" FIRST 1 to w55_sub_del_var.bat
EXPORT "DELETE v_len_count OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_input_pattern OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_input_pattern2 OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_choose_field OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_new_field OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_new_table_name OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_loop_number OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_number_of_digits OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_count OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_string_pattern  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_number_of_patterns OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_len_pattern_string  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_pattern_number OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_field_name OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_count_pattern_fields OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_count_underscore OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_pattern_field_name_wo_n OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_number_of_open_table_fields OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_tmp_check  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_define_pattern_name OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_pattern_first_number OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_count_define_pattern OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_start_loop OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_pattern_view OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_defaultview_open_fields OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_new_split_pattern OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_get_number_of_patterns OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_len_pattern OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_column_name OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_count_loop OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_min_max_or_pattern OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_pattern_viewname OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_19 OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_18 OK " FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_17 OK " FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_16  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_15  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_14  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_13  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_12  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_11  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_10  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_09  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_08  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_07  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_06  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_05  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_04  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_03  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_02  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_line_01  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_03_title    OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_06  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_radio_01 OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_05  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_04  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_03  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_02  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_line_01  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_02_title    OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_06  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_05  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_04  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_03  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_02  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_line_01  OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_radio_01 OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_01_title    OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_dialog_pause_1    OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_min_max_values     OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_max_length         OK" FIRST 1 TO w55_sub_del_var.bat APPEND
EXPORT "DELETE v_min_length         OK" FIRST 1 TO w55_sub_del_var.bat APPEND
COMMENT --- End ------------ DELETE VARIABLES - sub script -------------------------------------


DO SCRIPT w55_sub_del_var


COMMENT --- Begin ---------- Dialog 1 --------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_01_title      ='Look for pattern'

IF v_default_language='EN' v_dialog_01_line_01    ='Choose minimum and maximum or pattern:'
IF v_default_language='EN' v_dialog_01_radio_01   ='Minimum and maximum;Pattern'
IF v_default_language='EN' v_dialog_01_line_02    ='This script looks for pattern in a field.'
IF v_default_language='EN' v_dialog_01_line_03    ='It is possible to choose between:'
IF v_default_language='EN' v_dialog_01_line_04    ='- minimum and maximum number of characters (looks between spaces)'
IF v_default_language='EN' v_dialog_01_line_05    ='- pattern (looks character by character).'
IF v_default_language='EN' v_dialog_01_line_06    ="Another dialogbox will show when you click 'OK'."
COMMENT --- End -- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_01_title      ='Sg efter mnster'

IF v_default_language='DA' v_dialog_01_line_01    ='Vlg mellem minimum og maksimum eller mnster:'
IF v_default_language='DA' v_dialog_01_radio_01   ='Minimum og maksimum;Mnster'
IF v_default_language='DA' v_dialog_01_line_02    ='Scriptet leder efter et mnster i et felt.'
IF v_default_language='DA' v_dialog_01_line_03    ='Det er muligt at vlge mellem:'
IF v_default_language='DA' v_dialog_01_line_04    ='- minimum og maksimum antal karakterer (undersger mellem mellemrum)'
IF v_default_language='DA' v_dialog_01_line_05    ='- mnster (karakter efter karakter).'
IF v_default_language='DA' v_dialog_01_line_06    ="En anden dialogboks kommer frem, nr du klikker 'OK'."
COMMENT --- End -- DA -----

COMMENT --- End ------------ Dialog 1 --------------------------------------


COMMENT --- Begin ---------- Dialog 2 --------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_02_title      ='Minimum and maximum length'

IF v_default_language='EN' v_dialog_02_line_01    ='Minimum length:'
IF v_default_language='EN' v_dialog_02_line_02    ='Maximum length:'
IF v_default_language='EN' v_dialog_02_line_03    ='Choose field:'
IF v_default_language='EN' v_dialog_02_line_04    ='Write a new fieldname:'
IF v_default_language='EN' v_dialog_02_line_05    ='Write a new tablename:'
IF v_default_language='EN' v_dialog_02_radio_01   ='All characters;Only digits'
IF v_default_language='EN' v_dialog_02_line_06    ="Specifikations:"
COMMENT --- End -- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_02_title      ='Minimum og maksimum lngde'

IF v_default_language='DA' v_dialog_02_line_01    ='Minmum lngde:'
IF v_default_language='DA' v_dialog_02_line_02    ='Maksimum lngde:'
IF v_default_language='DA' v_dialog_02_line_03    ='Vlg felt:'
IF v_default_language='DA' v_dialog_02_line_04    ='Skriv et nyt feltnavn:'
IF v_default_language='DA' v_dialog_02_line_05    ='Skriv et nyt tabelnavn:'
IF v_default_language='DA' v_dialog_02_radio_01   ='Alle karakterer;Kun cifre'
IF v_default_language='DA' v_dialog_02_line_06    ="Specifikationer:"
COMMENT --- End -- DA -----

COMMENT --- End ------------ Dialog 2 --------------------------------------


COMMENT --- Begin ---------- Dialog 3 --------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_03_title      ='Pattern'

IF v_default_language='EN' v_dialog_03_line_01    ='INFORMATION:'
IF v_default_language='EN' v_dialog_03_line_02    ='Look for a pattern in a field'
IF v_default_language='EN' v_dialog_03_line_03    ='SCRIPT INPUT'
IF v_default_language='EN' v_dialog_03_line_04    ='Match any alphabetic character (a-z, A-Z, European characters). This format type is not case-sensitive. You can use X or x.'
IF v_default_language='EN' v_dialog_03_line_05    ='Write the pattern you are looking for:'
IF v_default_language='EN' v_dialog_03_line_06    ="Choose a field to search in:"
IF v_default_language='EN' v_dialog_03_line_07    ="Type a name for the new pattern field:"
IF v_default_language='EN' v_dialog_03_line_08    ="FORMAT TYPE:"
IF v_default_language='EN' v_dialog_03_line_09    ="DESCRIPTION:"
IF v_default_language='EN' v_dialog_03_line_10    ="Match any number."
IF v_default_language='EN' v_dialog_03_line_11    ="Match any non-blank character."
IF v_default_language='EN' v_dialog_03_line_12    ="Match any character."
IF v_default_language='EN' v_dialog_03_line_13    ="An escape character that lets you specify that the following character is a literal, regardless of its value. This is useful if you want to match on any of the format characters listed above."
IF v_default_language='EN' v_dialog_03_line_14    ="EXAMPLE:"
IF v_default_language='EN' v_dialog_03_line_15    ="If you are looking for a date with the format YYYY-MM-DD - you can type 9999-99-99."
IF v_default_language='EN' v_dialog_03_line_16    ="Type a name for the new table:"
IF v_default_language='EN' v_dialog_03_line_17    ="RESULT:"
IF v_default_language='EN' v_dialog_03_line_18    ="Choosen fieldname and pattern in a new table."
IF v_default_language='EN' v_dialog_03_line_19    ="X or x"
COMMENT --- End -- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_03_title      ='Mnster'

IF v_default_language='DA' v_dialog_03_line_01    ='INFORMATION:'
IF v_default_language='DA' v_dialog_03_line_02    ='Sg efter et mnster i et felt'
IF v_default_language='DA' v_dialog_03_line_03    ='SCRIPT INPUT'
IF v_default_language='DA' v_dialog_03_line_04    ='Matcher ethvert bogstav (a-z, A-Z, europiske karakterer). Tager ikke hensyn til store og sm bogstaver. Man kan bruge X eller x.'
IF v_default_language='DA' v_dialog_03_line_05    ='Skriv det mnster du leder efter:'
IF v_default_language='DA' v_dialog_03_line_06    ="Vlg felt du nsker at sge i:"
IF v_default_language='DA' v_dialog_03_line_07    ="Skriv et navn til det nye felt:"
IF v_default_language='DA' v_dialog_03_line_08    ="FORMAT TYPE:"
IF v_default_language='DA' v_dialog_03_line_09    ="BESKRIVELSE:"
IF v_default_language='DA' v_dialog_03_line_10    ="Matcher et nummer."
IF v_default_language='DA' v_dialog_03_line_11    ="Matcher ikke blanke karakterer."
IF v_default_language='DA' v_dialog_03_line_12    ="Matcher hvilken som helst karakter."
IF v_default_language='DA' v_dialog_03_line_13    ="Tegn man kan skrive foran, hvis man nsker at finde et af ovenstende tegn. Eksempelvis vil /9 lede efter 9 og ikke et tilfldigt cifre, som 9 reprsenterer."
IF v_default_language='DA' v_dialog_03_line_14    ="EKSEMPEL:"
IF v_default_language='DA' v_dialog_03_line_15    ="Hvis man leder efter et mnster, som har datoformaet YYYY-MM-DD, kan man skrive 9999-99-99."
IF v_default_language='DA' v_dialog_03_line_16    ="Skriv et navn til den nye tabel:"
IF v_default_language='DA' v_dialog_03_line_17    ="RESULTAT:"
IF v_default_language='DA' v_dialog_03_line_18    ="Valgt feltnavn og mnster i en ny tabel."
IF v_default_language='DA' v_dialog_03_line_19    ="X eller x"
COMMENT --- End -- EN -----

COMMENT --- End ------------ Dialog 3 --------------------------------------


COMMENT --- Begin ---------- Pause 1 - no match --------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_pause_1 ='There are no matches'
COMMENT --- End ---- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_pause_1 ='Intet matcher'
COMMENT --- End ---- DA -----

COMMENT --- End __---------- Pause 1 - no match --------------------------------------


COUNT
v_len_count=LENGTH(ALLTRIM(STRING(COUNT1 12)))

DIALOG (DIALOG TITLE "%v_dialog_01_title%" WIDTH 487 HEIGHT 284 ) (BUTTONSET TITLE "&OK;&Cancel" AT 396 216 DEFAULT 1 ) (TEXT TITLE "%v_dialog_01_line_01%" AT 96 148 WIDTH 252 ) (RADIOBUTTON TITLE "%v_dialog_01_radio_01%" TO "v_min_max_or_pattern" AT 96 168 DEFAULT 1 ) (TEXT TITLE "%v_dialog_01_line_02%" AT 24 28 ) (TEXT TITLE "%v_dialog_01_line_03%" AT 24 64 WIDTH 427 ) (TEXT TITLE "%v_dialog_01_line_04%" AT 24 88 WIDTH 361 ) (TEXT TITLE "%v_dialog_01_line_05%" AT 24 112 ) (TEXT TITLE "%v_dialog_01_line_06%" AT 36 244 )

if v_min_max_or_pattern= 1 DIALOG (DIALOG TITLE "%v_dialog_02_title%" WIDTH 526 HEIGHT 349 ) (BUTTONSET TITLE "&OK;&Cancel" AT 420 276 DEFAULT 1 ) (TEXT TITLE "%v_dialog_02_line_01%" AT 24 64 ) (TEXT TITLE "%v_dialog_02_line_02%" AT 24 100 ) (EDIT TO "v_min_length" AT 156 60 WIDTH 53 ) (EDIT TO "v_max_length" AT 156 96 WIDTH 53 ) (TEXT TITLE "%v_dialog_02_line_03%" AT 24 28 ) (ITEM TITLE "C" TO "v_choose_field" AT 156 24 WIDTH 198 ) (TEXT TITLE "%v_dialog_02_line_04%" AT 24 148 WIDTH 115 ) (EDIT TO "v_new_field" AT 156 144 WIDTH 249 ) (TEXT TITLE "%v_dialog_02_line_05%" AT 24 196 WIDTH 124 ) (EDIT TO "v_new_table_name" AT 156 192 WIDTH 249 ) (RADIOBUTTON TITLE "%v_dialog_02_radio_01%" TO "v_min_max_values" AT 156 252 DEFAULT 1 ) (TEXT TITLE "%v_dialog_02_line_06%" AT 24 256 )
if v_min_max_or_pattern= 2 DIALOG (DIALOG TITLE "%v_dialog_03_title%" WIDTH 856 HEIGHT 573 ) (BUTTONSET TITLE "&OK;&Cancel" AT 744 492 DEFAULT 1 ) (TEXT TITLE "%v_dialog_03_line_01%" AT 24 28 ) (TEXT TITLE "%v_dialog_03_line_02%" AT 156 28 WIDTH 443 HEIGHT 22 ) (TEXT TITLE "%v_dialog_03_line_03%" AT 24 388 ) (TEXT TITLE "%v_dialog_03_line_19%" AT 156 112 ) (TEXT TITLE "%v_dialog_03_line_04%" AT 300 112 WIDTH 436 HEIGHT 29 ) (TEXT TITLE "9" AT 156 148 ) (TEXT TITLE "%v_dialog_03_line_05%" AT 156 388 ) (EDIT TO "v_input_pattern" AT 396 384 WIDTH 295 ) (TEXT TITLE "%v_dialog_03_line_06%" AT 156 424 ) (TEXT TITLE "%v_dialog_03_line_07%" AT 156 460 WIDTH 204 HEIGHT 20 ) (TEXT TITLE "%v_dialog_03_line_08%" AT 156 64 ) (TEXT TITLE "%v_dialog_03_line_09%" AT 300 64 ) (TEXT TITLE "=============" AT 156 88 ) (TEXT TITLE "=============" AT 300 88 ) (TEXT TITLE "%v_dialog_03_line_10%" AT 300 148 ) (TEXT TITLE "!" AT 156 172 ) (TEXT TITLE "%v_dialog_03_line_11%" AT 300 172 ) (TEXT TITLE "?" AT 156 196 ) (TEXT TITLE "%v_dialog_03_line_12%" AT 300 196 ) (TEXT TITLE "\" AT 156 220 ) (TEXT TITLE "%v_dialog_03_line_13%" AT 300 220 WIDTH 471 HEIGHT 33 ) (TEXT TITLE "%v_dialog_03_line_14%" AT 24 292 ) (TEXT TITLE "%v_dialog_03_line_15%" AT 156 292 ) (ITEM TITLE "CND" TO "v_choose_field" AT 396 420 WIDTH 294 HEIGHT 121 ) (EDIT TO "v_new_field" AT 396 456 WIDTH 296 ) (TEXT TITLE "%v_dialog_03_line_16%" AT 156 496 ) (EDIT TO "v_new_table_name" AT 396 492 WIDTH 296 ) (TEXT TITLE "%v_dialog_03_line_17%" AT 24 340 ) (TEXT TITLE "%v_dialog_03_line_18%" AT 156 340 )

if v_min_max_or_pattern= 1 v_len_pattern=VALUE(v_max_length 0)



if v_min_max_or_pattern= 2 v_input_pattern2=v_input_pattern
if v_min_max_or_pattern= 2 v_len_pattern=LENGTH(v_input_pattern)

if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\x') if OCCURS(v_input_pattern '\x')<>0
if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\X') if OCCURS(v_input_pattern '\X')<>0
if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\9') if OCCURS(v_input_pattern '\9')<>0
if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\!') if OCCURS(v_input_pattern '\!')<>0
if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\?') if OCCURS(v_input_pattern '\?')<>0
if v_min_max_or_pattern= 2 v_len_pattern=v_len_pattern-OCCURS(v_input_pattern '\\') if OCCURS(v_input_pattern '\\')<>0



v_new_field=ALLTRIM(REPLACE(INCLUDE(v_new_field '%v_valid_characters%') ' ' '_'))
v_pattern_viewname='View_'+v_new_field
v_new_table_name=ALLTRIM(REPLACE(INCLUDE(v_new_table_name '%v_valid_characters%') ' ' '_'))

COM ********** BEGIN ********** Get fieldlength of choosen field **********
GROUP
  STATISTICS ON LENGTH(TRIM(%v_choose_field%)) NUMBER 1
  STATISTICS ON OCCURS(TRIM(%v_choose_field%) ' ') NUMBER 1
END
COM ********** END ************ Get fieldlength of choosen field **********

COM ********** BEGIN ********** Define record with recordnumber **********
DEFINE FIELD w55_Record_zoned COMPUTED ZONED(RECNO() %v_len_count%)
COM ********** END ************ Define record with recordnumber **********

COM ********** BEGIN ********** Find min and max in a field in record and extract to new file - subscript **********
EXPORT "v_loop_number=HIGH3+1"  FIRST 1 TO w55_sub_min_max_loop.bat
EXPORT "v_count=1"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "GROUP"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "v_count=1"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "LOOP WHILE v_count<=v_loop_number"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "if v_min_max_values=1 EXTRACT w55_Record_zoned SUBSTR(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count)) 1 v_len_pattern) AS 'INFO' IF BETWEEN(LENGTH(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count))) VALUE(v_min_length 0) VALUE(v_max_length 0)) to W55_TMP_EXT_MATCH_PATTERN"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "if v_min_max_values=2 EXTRACT w55_Record_zoned SUBSTR(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count)) 1 v_len_pattern) AS 'INFO' IF BETWEEN(LENGTH(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count))) VALUE(v_min_length 0) VALUE(v_max_length 0)) AND LENGTH(ALLTRIM(SUBSTR(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count)) 1 v_len_pattern)))=LENGTH(ALLTRIM(INCLUDE(ALLTRIM(SUBSTR(ALLTRIM(SPLIT(%v_choose_field% ' ' v_count)) 1 v_len_pattern)) '0987654321'))) TO W55_TMP_EXT_MATCH_PATTERN"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "v_count=v_count+1"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "END"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
EXPORT "END"  FIRST 1 TO w55_sub_min_max_loop.bat APPEND
COM ********** END ************ Find min and max in a field in record and extract to new file - subscript **********


COM ********** BEGIN ********** Find patterne in a field in record and extract to new file - subscript **********
EXPORT "v_loop_number=HIGH2+1-v_len_pattern+1"  FIRST 1 TO w55_sub_pattern_loop.bat
EXPORT "v_number_of_digits=LENGTH(ALLTRIM(STRING(HIGH2 12)))"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "v_count=1"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "GROUP"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "v_count=1"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "LOOP WHILE v_count<=v_loop_number"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "EXTRACT w55_Record_zoned SUBSTR(%v_choose_field% v_count v_len_pattern) AS 'INFO' IF MAP(SUBSTR(%v_choose_field% v_count v_len_pattern) '%v_input_pattern2%') to W55_TMP_EXT_MATCH_PATTERN"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "v_count=v_count+1"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "END"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
EXPORT "END"  FIRST 1 TO w55_sub_pattern_loop.bat APPEND
COM ********** END ************ Find patterne in a field in record and extract to new file - subscript **********


COM ********** BEGIN ********** Run min and max or pattern subscript **********
if v_min_max_or_pattern= 1 DO SCRIPT w55_sub_min_max_loop.bat
if v_min_max_or_pattern= 2 DO SCRIPT w55_sub_pattern_loop.bat
COM ********** END ************ Run min and max or pattern subscript **********

COM ********** BEGIN ********** Group pattern per record to w55_tmp_group_pattern **********
OPEN W55_TMP_EXT_MATCH_PATTERN

COUNT

IF COUNT1=0 PAUSE "%v_dialog_pause_1%"
IF COUNT1=0 SET EXACT %v_GetUserSetExactOnOff%
IF COUNT1=0 DELETE FORMAT  W55_TMP_EXT_MATCH_PATTERN OK
IF COUNT1=0 DELETE W55_TMP_EXT_MATCH_PATTERN.FIL OK
IF COUNT1=0 OPEN "%v_GetOpenTableName%"
IF COUNT1=0 DO SCRIPT e_audit_DEL_GetACLandTableInfo
IF COUNT1=0 DO SCRIPT w55_sub_del_var
IF COUNT1=0 DELETE SCRIPT w55_sub_min_max_loop OK
IF COUNT1=0 DELETE w55_sub_min_max_loop.bat OK
IF COUNT1=0 DELETE SCRIPT w55_sub_pattern_loop OK
IF COUNT1=0 DELETE w55_sub_pattern_loop.bat OK
IF COUNT1=0 DELETE FIELD w55_Record_zoned OK
IF COUNT1=0 DELETE w55_sub_del_var.bat OK

ESCAPE IF COUNT1=0 

DEFINE FIELD w55_Record_zoned_offset_1 COMPUTED RECOFFSET(w55_Record_zoned 1)
EXT FIELD w55_Record_zoned w55_Record_zoned_offset_1 INFO TO w55_tmp_ext_match_pattern_02 OPEN

v_string_pattern=BLANKS(2000)

GROUP
  v_string_pattern=ALLTRIM(v_string_pattern)+'#'+ALLTRIM(INFO)

  EXTRACT w55_Record_zoned ALLTRIM(v_string_pattern)+'#' AS 'PATTERN_STRING' if w55_Record_zoned<>w55_Record_zoned_offset_1 to w55_tmp_group_pattern
  v_string_pattern='' if w55_Record_zoned<>w55_Record_zoned_offset_1
END

CLOSE
DELETE FORMAT w55_tmp_ext_match_pattern_02 OK
DELETE w55_tmp_ext_match_pattern_02.fil OK
COM ********** END ************ Group pattern per record to w55_tmp_group_pattern **********


COM ********** BEGIN ********** Find next pattern name **********


OPEN w55_tmp_group_pattern

GROUP
  STATISTICS ON OCCURS(PATTERN_STRING '#') NUMBER 1
  STATISTICS ON LENGTH(ALLTRIM(PATTERN_STRING)) NUMBER 1
END

v_number_of_patterns=HIGH2-1
v_len_pattern_string=HIGH3-v_number_of_patterns

v_pattern_number=0
v_field_name=BLANKS(31)
v_count_pattern_fields=1
v_pattern_first_number=0
v_count_underscore=OCCURS(v_new_field '_')

v_pattern_field_name_wo_n=v_new_field

IF OCCURS(v_new_field '_')<>0 AND LENGTH(INCLUDE(SUBSTR(REVERSE(ALLTRIM(v_new_field)) 1 1) '0987654321'))=1 v_pattern_field_name_wo_n=SUBSTR(v_new_field 1 AT( OCCURS(v_new_field '_')  '_'  v_new_field )-1)
IF substr(REVERSE(ALLTRIM(v_new_field)) 1 1)='_'   v_pattern_field_name_wo_n=REVERSE(SPLIT(REVERSE(ALLTRIM(v_new_field)) '_' OCCURS(v_new_field '_')))
IF LENGTH(INCLUDE(SUBSTR(REVERSE(ALLTRIM(v_new_field)) 1 1) '0987654321'))=0 v_pattern_field_name_wo_n=ALLTRIM(v_new_field)
v_pattern_field_name_wo_n=v_pattern_field_name_wo_n+'_'



GROUP FIRST 1
  v_count_pattern_fields=1
  v_pattern_first_number=0
  v_number_of_open_table_fields=OCCURS(v_GetFieldnames '#')
  LOOP WHILE v_count_pattern_fields<=v_number_of_open_table_fields+1
    v_field_name=ALLTRIM(SPLIT(v_GetFieldnames '#' v_count_pattern_fields))
    v_pattern_number=VALUE(v_field_name 0)    if SUBSTR(UPPER(v_field_name) 1 LENGTH(ALLTRIM(v_pattern_field_name_wo_n)))=v_pattern_field_name_wo_n 
    v_pattern_first_number=v_pattern_number   if SUBSTR(UPPER(v_field_name) 1 LENGTH(ALLTRIM(v_pattern_field_name_wo_n)))=v_pattern_field_name_wo_n  and v_pattern_number>v_pattern_first_number 
    v_count_pattern_fields=v_count_pattern_fields+1 
  END
END

v_pattern_first_number=v_pattern_first_number+1
v_tmp_check=v_pattern_first_number



EXPORT "v_define_pattern_name=ALLTRIM(v_pattern_field_name_wo_n)+ALLTRIM(STRING(v_pattern_first_number 5))" FIRST 1 TO w55_sub_find_pattern_in_field.bat
EXPORT "DEFINE FIELD %"+"v_define_pattern_name"+"% COMPUTED " FIRST 1 TO w55_sub_find_pattern_in_field.bat APPEND
EXPORT "WIDTH %"+"v_len_pattern_string"+"%" FIRST 1 TO w55_sub_find_pattern_in_field.bat APPEND
EXPORT "SUBSTR(ALLTRIM(SUBSTR(PATTERN_STRING AT(%"+"v_count_define_pattern"+"% '#' PATTERN_STRING)+1 AT(%"+"v_count_define_pattern"+"%+1 '#' PATTERN_STRING)-AT(%"+"v_count_define_pattern"+"% '#' PATTERN_STRING)-1)) 1 "+"%"+"v_len_pattern"+"%"+")  " FIRST 1 TO w55_sub_find_pattern_in_field.bat APPEND
EXPORT "v_pattern_first_number=v_pattern_first_number+1" FIRST 1 TO w55_sub_find_pattern_in_field.bat APPEND
EXPORT "v_count_define_pattern=v_count_define_pattern+1" FIRST 1 TO w55_sub_find_pattern_in_field.bat APPEND

v_count_define_pattern=1
DO w55_sub_find_pattern_in_field while v_count_define_pattern<=v_number_of_patterns


DELETE SCRIPT w55_sub_find_pattern_in_field OK
DELETE w55_sub_find_pattern_in_field.bat  OK
COM ********** END ************ Find next pattern name **********

COM ********** BEGIN ********** Create string of pattern fieldnames **********
v_start_loop = v_pattern_number+1
v_pattern_view=BLANKS(2000)

GROUP FIRST 1
  v_pattern_view=''
  LOOP WHILE v_start_loop<v_pattern_first_number
    v_pattern_view=ALLTRIM(v_pattern_view)+' '+ALLTRIM(v_pattern_field_name_wo_n)+ALLTRIM(STRING(v_start_loop 5))
    v_start_loop=v_start_loop+1
  END 
END

v_pattern_view=ALLTRIM(v_pattern_view)
v_defaultview_open_fields=REPLACE('%v_GetOpenViewFieldName%' '#' ' ')
COM ********** END ************ Create string of pattern fieldnames **********

COM ********** BEGIN ********** Join original file view with new pattern **********
OPEN "%v_GetOpenTableName%" PRIMARY
OPEN w55_tmp_group_pattern SECONDARY



JOIN PKEY w55_Record_zoned FIELDS %v_defaultview_open_fields% w55_Record_zoned SKEY w55_Record_zoned WITH w55_Record_zoned %v_pattern_view% PRIMARY TO "j_w55_open_table_pattern" PRESORT SECSORT


CLOSE PRIMARY SECONDARY
COM ********** END ************ Join original file view with new pattern **********

COM ********** BEGIN ********** Delete tmp fields and create new extract table **********
OPEN j_w55_open_table_pattern
DELETE FIELD w55_Record_zoned OK
DELETE FIELD w55_Record_zoned2 OK

EXTRACT FIELDS ALL TO '%v_new_table_name%' OPEN
DEFINE VIEW %v_GetOpenViewName% OK
DEFINE VIEW %v_pattern_viewname% OK
DEFINE COLUMN %v_pattern_viewname% %v_choose_field%


  COM ********** BEGIN ********** Create subscript w55_sub_default_view **********
  EXPORT "v_column_name=SPLIT(v_GetOpenViewFieldName '#' v_count_loop)" FIRST 1 to w55_sub_default_view.bat
  EXPORT "DELETE COLUMN %"+"v_GetOpenViewName"+"% %"+"v_column_name"+"% OK" FIRST 1 to w55_sub_default_view.bat APPEND
  EXPORT "DEFINE COLUMN %"+"v_GetOpenViewName"+"% %"+"v_column_name"+"% " FIRST 1 to w55_sub_default_view.bat APPEND
  EXPORT "v_count_loop=v_count_loop+1" FIRST 1 to w55_sub_default_view.bat APPEND
  COM ********** END ************ Create subscript w55_sub_default_view **********

  COM ********** BEGIN ********** Create subscript w55_sub_default_view_pattern **********
  EXPORT "if v_len_pattern<10 v_len_pattern=12" FIRST 1 to w55_sub_default_view_pattern.bat
  EXPORT "v_column_name=SPLIT(v_new_split_pattern '#' v_count_loop)" FIRST 1 to w55_sub_default_view_pattern.bat APPEND
  EXPORT "DELETE COLUMN %"+"v_GetOpenViewName"+"% %"+"v_column_name"+"% OK" FIRST 1 to w55_sub_default_view_pattern.bat APPEND
  EXPORT "DEFINE COLUMN %"+"v_pattern_viewname"+"% %"+"v_column_name"+"% WIDTH %"+"v_len_pattern"+"%" FIRST 1 to w55_sub_default_view_pattern.bat APPEND
  EXPORT "v_count_loop=v_count_loop+1" FIRST 1 to w55_sub_default_view_pattern.bat APPEND
  COM ********** BEGIN ********** Create subscript w55_sub_default_view_pattern **********


v_count_loop=1
DO SCRIPT w55_sub_default_view while v_count_loop<=v_GetOpenViewFieldNumber

DELETE SCRIPT w55_sub_default_view OK
DELETE w55_sub_default_view.bat OK


v_count_loop=1
v_new_split_pattern=REPLACE(ALLTRIM('%v_pattern_view%') ' ' '#')
v_get_number_of_patterns=OCCURS(ALLTRIM('%v_new_split_pattern%') '#')+1

DO SCRIPT w55_sub_default_view_pattern while v_count_loop<=v_get_number_of_patterns


DELETE SCRIPT w55_sub_default_view_pattern OK
DELETE w55_sub_default_view_pattern.bat OK
COM ********** END ********** Delete tmp fields and create new extract table **********



OPEN "%v_GetOpenTableName%"
DELETE FIELD w55_Record_zoned OK

OPEN %v_new_table_name%
CLOSE
OPEN %v_new_table_name%

SET EXACT %v_GetUserSetExactOnOff%

DO SCRIPT e_audit_DEL_GetACLandTableInfo

DELETE FORMAT j_w55_open_table_pattern OK
DELETE j_w55_open_table_pattern.fil OK

DELETE FORMAT W55_TMP_EXT_MATCH_PATTERN OK
DELETE W55_TMP_EXT_MATCH_PATTERN.fil OK

DELETE FORMAT w55_tmp_group_pattern OK
DELETE w55_tmp_group_pattern.fil OK

DELETE SCRIPT w55_sub_min_max_loop OK
DELETE w55_sub_min_max_loop.bat OK

DELETE SCRIPT w55_sub_pattern_loop OK
DELETE w55_sub_pattern_loop.bat OK

DO SCRIPT w55_sub_del_var OK

DELETE w55_sub_del_var.bat OK

SET SAFETY ON
SET ECHO ON

