*
COMMENT
COMMENT
COMMENT  
***************************************** DANISH ********************************************************
******************************** GENEREL INFORMATION OM SCRIPTET ********************************
*
 Beskrivelse:   Noter til bilag, transaktionsnr eller lignende karakterfelt.
*
 Forml:        Forml med scriptet er:
                At f mulighed for at indstte en note pr bilag eller lignende. ACL indbyggede kommando 
                til noter virker ikke.
*
 Forudstning:  Adgang til en tabel med feltindhold
*
 Input:         Dialog med opret, ndre eller slet note.
*
 Output:        Note pr. bilagsnr eller lignende placeret i viewet.
*
 Applications:  10 Diverse - Note pr bilag eller lignende
*
 Dato:          Udviklet:  v 1.0   2011-03-17 (w00055, Note pr bilagsnr eller lignende )
                Opdateret: v 1.1   2011-05-18 (W00055, ndret. Quick Sort bliver slet fra, s scriptet virker) 
                           v 1.2   2011-06-07 (W00055, ndret. midlertidig fil slettet) 
                           v 1.3   2011-11-22 (w00055, ndret. Check og aktiver evt. filter samt engelsk version)
*
 Version:       1.3
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055.
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
*
 Beskrivelse:   1. Undersger om Quick Sort er slet til.
                2. Opretter, ndre eller sletter note pr bilagsnr eller lignende hvis Quick Sort er slet fra.
                3. Opretter en tabel med noterne, som der bliver relateret til.
                4. Tilfjer feltet REC_NOTES fra relateret tabel i viewet.
END

COMMENT  
***************************************** ENGLISH ********************************************************
******************************** GENEREL INFORMATION ABOUT THE SCRIPTET ********************************
*
 Description:   Notes per document number, transaction number or simlar character field.
*
 Purpose:       The purpose with the script is:
                To write a note per document number or simlar.
*
 Precondition:  Access to a table with at least one character field.
*
 Input:         Dialog with create, chance or delete a note.
*
 Output:        Note per document number, transaction number or simlar placed in the view.
*
 Applications:  (used in DK)
*
 Dato:          Developed: v 1.0   2011-03-17 (w00055, Note per voucher or simlar )
                Updated:   v 1.1   2011-05-18 (W00055, Changed. Quick Sort turned off) 
                           v 1.2   2011-06-07 (W00055, Changed. Temp. file deleted) 
                           v 1.3   2011-11-22 (w00055, Changed. Check and activate for active filter and English version)
*
 Version:       1.3
*
 Developed by:  Working group: Scripts
                Contact person: Erling T Petersen. E-mail: erling.petersen@skat.dk
*
 Copyright:     The script is made to help script developers in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
 Description:   1. Check for filter and active Quick Sort.
                2. Create, change or delete note per document number or simlar if Quick Sort is off.
                3. Create a table with notes. A relation with the notes will be createt.
                4. Add the field REC_NOTES from the related table in the Default_View.
END

COMMENT --- BEGIN --- SCRIPT NOTES -------------------------------------------------------------------------

SET ECHO NONE
SET SAFETY OFF

DELETE SCRIPT e_audit_REC_NOTE_PER_DOC_NUM OK



COMMENT -------------------------- Language - Begin ------------------------------------------

COMMENT ----- v_default_language og v_valid_characters ------
DO SCRIPT Func_v_GetLanguage


COM ----- DANISH --- Begin --------------------------------------------------------------------

COM ----- DIALOG 1 ---DANISH --- Begin -------

IF v_default_language='DA' v_dialog_01_title      ='Note'

IF v_default_language='DA' v_dialog_01_line_01    ='1: ben en tabel.'
IF v_default_language='DA' v_dialog_01_line_02    ='2: Marker et recordnummer.'
IF v_default_language='DA' v_dialog_01_line_03    ='3: Kr scriptet igen.'


COM ----- DIALOG 1 ---DANISH --- End -------


COM ----- DIALOG 2 ---DANISH --- Begin -------

IF v_default_language='DA' v_dialog_02_title      ='Noter i tabel'

IF v_default_language='DA' v_dialog_02_line_01    ='Scriptet krver en unik ngle, som noterne kan blive relateret til. Det kan vre bilagsnr., transaktionsnummer, r+bilagsnr. eller lignende. '
IF v_default_language='DA' v_dialog_02_line_02    ='Er der et nglefelt blandt felterne, som man kan bruge?.'
IF v_default_language='DA' v_dialog_02_line_03    ='Hvis der ikke er noget nglefelt, stopper scriptet. Opret et nglefelt og kr scriptet igen.'
IF v_default_language='DA' v_dialog_02_radiobutton    ='Ja;Nej'

COM ----- DIALOG 2 ---DANISH --- End -------

COM ----- DIALOG 3 ---DANISH --- Begin -------

IF v_default_language='DA' v_dialog_03_title      ='Vlg bilagsnr. eller andet unik ngle'

IF v_default_language='DA' v_dialog_03_line_01    ='Vlg bilagsnr. eller andet unik ngle'

COM ----- DIALOG 3 ---DANISH --- End -------



COM ----- DIALOG 4 ---DANISH --- Begin -------

IF v_default_language='DA' v_dialog_04_title      ='Note'

IF v_default_language='DA' v_dialog_04_line_01    ='Note'
IF v_default_language='DA' v_dialog_04_line_02    ='Noten bliver oprettet, ndret eller slettet ved den record, der er markeret.'

COM ----- DIALOG 4 ---DANISH --- End -------


COM ----- DIALOG 5 ---DANISH --- Begin -------

IF v_default_language='DA' v_dialog_05_title      ='Meddelelse'

IF v_default_language='DA' v_dialog_05_line_01    ='Hvis der ikke er tilknyttet andre noter til tabellen, vil noten automatisk blive indsat i Default_View position 1.'
IF v_default_language='DA' v_dialog_05_line_02    ='Hvis der er tilknyttet noter til tabellen i forvejen, skal man selv tilfje feltet med noten manuelt. Hjreklik og vlg [ Add Columns ]. Vlg herefter tabellen med noter i [ From Table ]. Tabellen starter med NO_ og noten str i feltet REC_NOTES.'

COM ----- DIALOG 5 ---DANISH --- End -------



IF v_default_language='DA' v_pause_line_01        ='Quick Sort bliver automatisk slet fra. Oprettelse, ndring eller sletning af noter virker ikke sammen med Quick Sort. Kr scriptet igen.'

IF v_default_language='DA' v_CreateChangeDelete   ='Opret eller ndre;Slet'

IF v_default_language='DA' v_TitleCCD_note        =' note'


COM ----- DANISH --- End ----------------------------------------------------------------------


COM ----- ENGLISH --- Begin -------------------------------------------------------------------


COM ----- DIALOG 1 --- ENGLISH --- Begin -------

IF v_default_language='EN' v_dialog_01_title      ='Note'

IF v_default_language='EN' v_dialog_01_line_01    ='1: Open a table.'
IF v_default_language='EN' v_dialog_01_line_02    ='2: Mark a record number.'
IF v_default_language='EN' v_dialog_01_line_03    ='3: Run the script again.'


COM ----- DIALOG 1 --- ENGLISH --- End -------

COM ----- DIALOG 2 --- ENGLISH --- Begin -------

IF v_default_language='EN' v_dialog_02_title      ='Notes in a table'

IF v_default_language='EN' v_dialog_02_line_01    ='The script demands a unique key, which the notes can relate to. It can be document number, transaction number, year+document number ect. '
IF v_default_language='EN' v_dialog_02_line_02    ='Is there a key field among the fields, which you can use.?.'
IF v_default_language='EN' v_dialog_02_line_03    ='If there is no key field, the script stops. Create a key field and run the script again.'
IF v_default_language='EN' v_dialog_02_radiobutton    ='Yes;No'

COM ----- DIALOG 2 ---ENGLISH --- End -------

COM ----- DIALOG 3 ---ENGLISH --- Begin -------

IF v_default_language='EN' v_dialog_03_title      ='Choose document number og another unique key'

IF v_default_language='EN' v_dialog_03_line_01    ='Choose document number og another unique key'

COM ----- DIALOG 3 ---ENGLISH --- End -------


COM ----- DIALOG 4 ---ENGLISH --- Begin -------

IF v_default_language='EN' v_dialog_04_title      ='Note'

IF v_default_language='EN' v_dialog_04_line_01    ='Note'
IF v_default_language='EN' v_dialog_04_line_02    ='The note will be created, changed or deleted at the marked record.'

COM ----- DIALOG 4 ---ENGLISH --- End -------


COM ----- DIALOG 5 ---ENGLISH --- Begin -------

IF v_default_language='EN' v_dialog_05_title      ='Information'

IF v_default_language='EN' v_dialog_05_line_01    ='If there are no other notes related to the table, the note will automatic be placed in Default_View position 1'
IF v_default_language='EN' v_dialog_05_line_02    ='If there already are notes related to the table you have to add the field with the note manually. Right clich and choose- [ Add Columns ]. Choose the table with the notes - use [ From Table ]. The table start with NO_ and the note is in field RE_NOTES.'

COM ----- DIALOG 5 ---ENGLISH --- End -------





IF v_default_language='EN' v_pause_line_01        ='Quick Sort Off will be set automatically. Create, change or delete notes do not work together with Quick Sort. Run the script again.'

IF v_default_language='EN' v_CreateChangeDelete   ='Create or change;Delete'

IF v_default_language='EN' v_TitleCCD_note        =' note'

COM ----- ENGLISH --- End --------------------------------------------------------------------


COMMENT -------------------------- Language - End --------------------------------------------






COM ----- DIALOG 1 ----- Begin -------

v_dialog_01 = '(DIALOG TITLE "%v_dialog_01_title%" WIDTH 364 HEIGHT 100 )'
v_dialog_01 = v_dialog_01 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 264 12 DEFAULT 1 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_01%" AT 24 16 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_02%" AT 24 40 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_03%" AT 24 64 )'

COM ----- DIALOG 1 ----- End -------


COM ----- DIALOG 2 ----- Begin -------

v_dialog_02 = '(DIALOG TITLE "%v_dialog_02_title%" WIDTH 493 HEIGHT 199 )'
v_dialog_02 = v_dialog_02 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 396 120 DEFAULT 1 )'
v_dialog_02 = v_dialog_02 +' '+'(TEXT TITLE "%v_dialog_02_line_01%" AT 24 28 WIDTH 416 HEIGHT 37 )'
v_dialog_02 = v_dialog_02 +' '+'(TEXT TITLE "%v_dialog_02_line_02%" AT 24 88 WIDTH 275 )'
v_dialog_02 = v_dialog_02 +' '+'(TEXT TITLE "%v_dialog_02_line_03%" AT 24 148 WIDTH 344 HEIGHT 32 )'
v_dialog_02 = v_dialog_02 +' '+'(RADIOBUTTON TITLE "%v_dialog_02_radiobutton%" TO "v_noteinfo" AT 336 84 DEFAULT 1 ) '

COM ----- DIALOG 2 ----- End -------


COM ----- DIALOG 3 ----- Begin -------

v_dialog_03 = '(DIALOG TITLE "%v_dialog_03_title%" WIDTH 459 HEIGHT 137 )'
v_dialog_03 = v_dialog_03 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 360 72 DEFAULT 1 )'
v_dialog_03 = v_dialog_03 +' '+'(TEXT TITLE "%v_dialog_03_line_01%" AT 24 16 )'
v_dialog_03 = v_dialog_03 +' '+'(ITEM TITLE "C" TO "v_KeyField" AT 24 48 WIDTH 302 )'

COM ----- DIALOG 3 ----- End -------


COM ----- DIALOG 4 ----- Begin -------

v_dialog_04 = '(DIALOG TITLE "%v_dialog_04_title%" WIDTH 319 HEIGHT 188 )'
v_dialog_04 = v_dialog_04 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 216 60 DEFAULT 1 )'
v_dialog_04 = v_dialog_04 +' '+'(TEXT TITLE "%v_dialog_04_line_01%" AT 24 16 )'
v_dialog_04 = v_dialog_04 +' '+'(RADIOBUTTON TITLE "%v_CreateChangeDelete%" TO "v_note_ccd" AT 24 48 WIDTH 140 DEFAULT 1 )'
v_dialog_04 = v_dialog_04 +' '+'(TEXT TITLE "%v_dialog_04_line_02%" AT 12 136 WIDTH 208 HEIGHT 30 )'

COM ----- DIALOG 4 ----- End -------


COM ----- DIALOG 5 ----- Begin -------

v_dialog_05 = '(DIALOG TITLE "%v_dialog_05_title%" WIDTH 431 HEIGHT 155 )'
v_dialog_05 = v_dialog_05 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 336 84 DEFAULT 1 )'
v_dialog_05 = v_dialog_05 +' '+'(TEXT TITLE "%v_dialog_05_line_01%" AT 24 16 WIDTH 285 HEIGHT 29)'
v_dialog_05 = v_dialog_05 +' '+'(TEXT TITLE "%v_dialog_05_line_02%" AT 24 64 WIDTH 281 HEIGHT 68 )'

COM ----- DIALOG 5 ----- End -------




COM --- BEGIN --- Get marked record -----
DELETE v_Recno OK
v_Recno=RECNO()
COM --- END ----- Get marked record -----

COM --- BEGIN --- Check for marked record -----
if v_recno=0 DIALOG %v_dialog_01%
ESCAPE if v_recno=0 
COM --- END ----- Check for marked record -----

if v_recno<>0 do script e_audit_GetTableFilterInfo

Do script e_audit_GetACLandTableInfo
IF v_GetUserSetExactOnOff='ON' SET EXACT OFF

SET ECHO NONE
SET SAFETY OFF

DIR ACLQSTMP.INX TO W55_TMP_QuickSort
OPEN W55_TMP_QuickSort
COUNT
v_count_quick=COUNT1
IF v_count_quick >=1 PAUSE "%v_pause_line_01%"

OPEN %v_GetOpenTableName%
IF v_count_quick >=1 DELETE ACLQSTMP.INX OK
IF v_count_quick >=1 DELETE FORMAT W55_TMP_QuickSort OK
IF v_count_quick >=1 DELETE W55_TMP_QuickSort.fil OK
IF v_count_quick >=1 ESCAPE



SET EXACT ON

OPEN %v_GetOpenTableName%

COM --- BEGIN --- Get note relation -----
v_NumberOfLoop=1
v_GetNoteRelationTable=BLANKS(31)
v_GetNoteRelationIndex=BLANKS(31)
v_GetNoteRelationField=BLANKS(31)
v_GetNoteRelationNumberTmp=0

GROUP FIRST 1
   LOOP WHILE v_NumberOfLoop<=v_GetNumberOfRelations
     v_GetNoteRelationNumberTmp=v_NumberOfLoop if SUBSTR(ALLTRIM(SPLIT(v_GetRelationTableName '#' v_NumberOfLoop)) 1 3)='NO_'
     v_NumberOfLoop=v_NumberOfLoop+1
   END
END

  v_GetNoteRelationTable=ALLTRIM(SPLIT(v_GetRelationTableName '#' v_GetNoteRelationNumberTmp))
  v_GetNoteRelationIndex=ALLTRIM(SPLIT(v_GetRelationIndex '#' v_GetNoteRelationNumberTmp)))
  v_GetNoteRelationField=ALLTRIM(SPLIT(v_GetRelationField '#' v_GetNoteRelationNumberTmp)))

DELETE v_NumberOfLoop OK

COM --- END --- Get note relation -----




if NOT ISBLANK(v_GetNoteRelationTable) v_noteinfo=1
if ISBLANK(v_GetNoteRelationTable) DIALOG %v_dialog_02%

if v_noteinfo=2 OPEN %v_GetOpenTableName%
ESCAPE if v_noteinfo=2 

SET FOLDER /NOTES

v_note_ccd_text=Blanks(256)
v_note_ccd_text=ALLTRIM(v_note_ccd_text)

if ISBLANK(v_GetNoteRelationTable) v_notesfile='NO_'+ALLTRIM(Substr(ALLTRIM('%v_GetOpenTableName%') 1 28))
if ISBLANK(v_GetNoteRelationIndex) v_notesfile_index='IN_'+ALLTRIM(Substr(ALLTRIM('%v_GetOpenTableName%') 1 28))
if NOT ISBLANK(v_GetNoteRelationTable) v_notesfile=v_GetNoteRelationTable
if NOT ISBLANK(v_GetNoteRelationIndex) v_notesfile_index=v_GetNoteRelationIndex

IF v_notesfile<>v_GetNoteRelationTable DIALOG %v_dialog_03%
IF v_notesfile<>v_GetNoteRelationTable SUMMARIZE ON %v_KeyField% AS '%v_KeyField%' OTHER Blanks(256) AS 'REC_NOTES' TO "%v_notesfile%" OPEN PRESORT
IF v_notesfile<>v_GetNoteRelationTable INDEX ON %v_KeyField% TO %v_notesfile_index% 
IF v_notesfile<>v_GetNoteRelationTable SET INDEX TO %v_notesfile_index%
IF v_notesfile<>v_GetNoteRelationTable OPEN %v_GetOpenTableName%
IF v_notesfile<>v_GetNoteRelationTable DEFINE RELATION %v_KeyField% WITH %v_notesfile% INDEX %v_notesfile_index%


LOCATE RECORD v_recno
IF v_notesfile=v_GetNoteRelationTable v_KeyField=v_GetNoteRelationField
v_KeyContentOrg=%v_KeyField%
v_note_content=ALLTRIM(%v_notesfile%.REC_NOTES)


DIALOG %v_dialog_04%


v_TitleCCD=ALLTRIM(SPLIT('%v_CreateChangeDelete%' ';' %v_note_ccd%))+' %v_TitleCCD_note%'

DIALOG (DIALOG TITLE "%v_TitleCCD%" WIDTH 683 HEIGHT 140 ) (BUTTONSET TITLE "&OK;&Cancel" AT 588 72 DEFAULT 1 ) (TEXT TITLE "%v_TitleCCD%:" AT 24 16 ) (EDIT TO "v_note_ccd_text" AT 24 36 WIDTH 643 DEFAULT "%v_note_content%" )

if v_note_ccd =2 v_note_ccd_text=BLANKS(0)

OPEN %v_notesfile%

   Ext %v_KeyField% REC_NOTES to tmp_rec_notes APPEND if '%v_KeyContentOrg%'<>%v_KeyField%
   EXT %v_KeyField% ALLTRIM('%v_note_ccd_text%') AS 'REC_NOTES' TO tmp_rec_notes APPEND  if '%v_KeyContentOrg%'=%v_KeyField%

OPEN tmp_rec_notes

EXTRACT ALL TO %v_notesfile% OPEN
INDEX ON %v_KeyField% TO %v_notesfile_index% 

OPEN %v_GetOpenTableName%

if isblank(v_GetNoteRelationTable) DIALOG %v_dialog_05%
if isblank(v_GetNoteRelationTable) DEFINE COLUMN Default_View %v_notesfile%.REC_NOTES POSITION 1 Width 10

SET FILTER %v_GetFilter%

SET EXACT %v_GetUserSetExactOnOff%

DELETE tmp_rec_notes.fil OK
DELETE FORMAT tmp_rec_notes OK

DELETE FORMAT W55_TMP_QuickSort OK
DELETE W55_TMP_QuickSort.fil OK

DELETE w55_tmp_filter_log.log OK
DELETE w55_tmp_log.log OK

DELETE v_CreateChangeDelete OK

COMMENT --- Begin --- Delete variables ----


DELETE v_note_ccd_text OK
DELETE v_TitleCCD OK
DELETE v_note_ccd OK
DELETE v_note_content OK
DELETE v_notesfile_index OK
DELETE v_notesfile OK
DELETE v_Recno OK
DELETE v_keyContentOrg OK
DELETE v_KeyField OK
DELETE v_noteinfo OK
DELETE v_TitleCCD_note OK

DELETE v_dialog_01_line_01 OK
DELETE v_dialog_01_line_02 OK
DELETE v_dialog_01_line_03 OK
DELETE v_dialog_01 OK

DELETE v_dialog_02_title OK
DELETE v_dialog_02_line_01 OK
DELETE v_dialog_02_line_02 OK
DELETE v_dialog_02_line_03 OK
DELETE v_dialog_02_radiobutton OK
DELETE v_dialog_02 OK

DELETE v_dialog_03_title OK
DELETE v_dialog_03_line_01 OK
DELETE v_dialog_03 OK

DELETE v_dialog_04_title OK
DELETE v_dialog_04_line_01 OK
DELETE v_dialog_04_line_02 OK
DELETE v_dialog_04 OK

DELETE v_dialog_05_title OK
DELETE v_dialog_05_line_01 OK
DELETE v_dialog_05_line_02 OK
DELETE v_dialog_05 OK

DELETE v_pause_line_01 OK

DELETE v_GetFilter OK
DELETE v_count_quick OK
DELETE v_GetNoteRelationNumberTmp OK
DELETE v_GetNoteRelationTable OK
DELETE v_GetNoteRelationIndex OK
DELETE v_GetNoteRelationField OK

DO SCRIPT e_audit_DEL_GetACLandTableInfo
COMMENT --- End ----- Delete variables ----

SET FOLDER /
SET EXACT OFF

DELETE v_GetOpenTableName OK


SET SAFETY ON
SET ECHO ON

