****************************** GENERAL INFORMATION OM SCRIPTET *********************************
*
*
COMMENT
COMMENT
COMMENT
****************************** GENERAL INFORMATION OM SCRIPTET *********************************
*
 Beskrivelse:   Opdeling af karakterfeltindhold i tabeller
*
 Forml:        Forml med scriptet er:
                At lave en automatisk opdeling i tabeller af karakterfeltindhold
*
 Forudstning:  Der er en tabel med karakterfelter, og der er adgang til subscript:
                Func_v_GetLanguage (valg af sprog)
                Func_v_GetACLandTableInfo (information om tabel og felter mv.)
                Func_DEL_GetACLandTableInfo (slet midlertidige variabler brugt i Func_v_GetACLandTableInfo)
*
 Begrnsning:   Engelsk version af ACL.
*
 Input:         Tabel og karakterfelt
*
 Output:        Tabeller med indhold fra karakterfelt.
*
 Applications:  10 Diverse
*
 Dato:          Udviklet:  2010-04-28
                Opdateret: 2010-05-12 
                           2010-08-30 (w00055, Erling Petersen, Nummering og engelsk udgave)
                           2010-11-01 (w00055, Erling Petersen, Tilpasset sprog script)
*
 Version:       3.1
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055.
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
END


COMMENT
****************************** GENERAL INFORMATION ABOUT THE SCRIPT *********************************
*
 Description:     Split content of a character field into tables.
*
 Purpose:         The purpose of the script is:
                  To make an automatic split of the content of a character field into tables.
*
 Pre-conditions:  There is a tabel with character fields and there are access to the following subscripts:
                  Func_v_GetLanguage (choose language)
                  Func_v_GetACLandTableInfo (information about table and fields and more)
                  Func_DEL_GetACLandTableInfo (delete temporary variables used in Func_v_GetACLandTableInfo)
*
 Limitations:     English version of ACL.
*
 Input:           Table and character field
*
 Output:          Tables with content of character field.
*
 Applications:    
*
 Date:            Developed:  2010-04-28
                  Updated:    2010-05-12 
                              2010-08-30 (w00055, Erling Petersen, Numbering and English edition)
                              2010-11-01 (w00055, Erling Petersen, Language script)
*
 Version:         3.1
*
 Developed by:    Working group:  Scripts
                  Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:       The script is made to help script developers in the Danish Tax Administration.
                  It is permissible to copy all or parts of the script, if you send an email to 
                  erling.petersen@skat.dk. It's free.
                  Please send an email to erling.petersen@skat.dk if you use the script, or have 
                  suggestions for improvement. 
                  It's nice to know if the script is being used.
*
END

COM -------------------------- Start ------------------------------------------


SET SAFETY OFF
SET ECHO NONE

DELETE BATCH e_audit_SPLIT_FI_CONT_INTO_TAB OK

COMMENT -------------------------- Language - Begin ------------------------------------------

COMMENT ----- v_default_language og v_valid_characters ------
DO SCRIPT Func_v_GetLanguage


COM ----- DANISH --- Begin --------------------------------------------------------------------

COM ----- DIALOG 3 ---DANISH --- Begin -------

IF v_default_language='DA' v_foldername_top       ='Opdel_Feltindhold'

COM -------- Det er en fordel at bruge 2 bogstaver som forkortelse ----------
IF v_default_language='DA' v_foldername_abbrev    ='OF'

IF v_default_language='DA' v_dialog_01_title      ='%v_foldername_abbrev%_%v_foldername_top%'

IF v_default_language='DA' v_dialog_01_line_01    ='SCRIPTET OPDELER INDHOLDET I ET KARAKTERFELT I TABELLER.'
IF v_default_language='DA' v_dialog_01_line_02    ='Eksempel:'
IF v_default_language='DA' v_dialog_01_line_03    ='Feltet R indeholder 2009 og 2010.'
IF v_default_language='DA' v_dialog_01_line_04    ='Scriptet opdeler rene i to tabeller.'
IF v_default_language='DA' v_dialog_01_line_05    ='%v_foldername_abbrev%_%v_foldername_top%'
IF v_default_language='DA' v_dialog_01_line_06    ='Tabel: FINANS'
IF v_default_language='DA' v_dialog_01_line_07    ='ACL folder:'
IF v_default_language='DA' v_dialog_01_line_08    ='%v_foldername_abbrev%01_FINANS'
IF v_default_language='DA' v_dialog_01_line_09    ='%v_foldername_abbrev%01_R'
IF v_default_language='DA' v_dialog_01_line_10    ='%v_foldername_abbrev%01_R_2009'
IF v_default_language='DA' v_dialog_01_line_11    ='%v_foldername_abbrev%01_R_2010'
IF v_default_language='DA' v_dialog_01_line_12    ='Vlg felt:'

COM ----- DIALOG 3 ---DANISH --- End -------

IF v_default_language='DA' v_pause_line_01        ='Scriptet er krt - se folder: '

COM ----- DANISH --- End ----------------------------------------------------------------------


COM ----- ENGLISH --- Begin -------------------------------------------------------------------


COM ----- DIALOG 3 --- ENGLISH --- Begin -------

IF v_default_language='EN' v_foldername_top       ='Split_Fieldcontent'

COM -------- Folder abbreviation ----------
IF v_default_language='EN' v_foldername_abbrev    ='SF'

IF v_default_language='EN' v_dialog_01_title      ='%v_foldername_abbrev%_%v_foldername_top%'

IF v_default_language='EN' v_dialog_01_line_01    ='THE SCRIPT SPLIT THE CONTENT OF A CHARACTER FIELD INTO TABLES.'
IF v_default_language='EN' v_dialog_01_line_02    ='Example:'
IF v_default_language='EN' v_dialog_01_line_03    ='The field YEAR contents 2009 and 2010.'
IF v_default_language='EN' v_dialog_01_line_04    ='The script split the year into two tables.'
IF v_default_language='EN' v_dialog_01_line_05    ='%v_foldername_abbrev%_%v_foldername_top%'
IF v_default_language='EN' v_dialog_01_line_06    ='Table: GENERAL_LEDGER'
IF v_default_language='EN' v_dialog_01_line_07    ='ACL folder:'
IF v_default_language='EN' v_dialog_01_line_08    ='%v_foldername_abbrev%01_GENERAL_LEDGER'
IF v_default_language='EN' v_dialog_01_line_09    ='%v_foldername_abbrev%01_YEAR'
IF v_default_language='EN' v_dialog_01_line_10    ='%v_foldername_abbrev%01_YEAR_2009'
IF v_default_language='EN' v_dialog_01_line_11    ='%v_foldername_abbrev%01_YEAR_2010'
IF v_default_language='EN' v_dialog_01_line_12    ='Choose field:'

COM ----- DIALOG 3 --- ENGLISH --- End -------

IF v_default_language='EN' v_pause_line_01        ='The script is done - see folder: '

COM ----- ENGLISH --- End --------------------------------------------------------------------


COMMENT -------------------------- Language - End --------------------------------------------


COM ----- DIALOG 1 ----- Begin -------

v_dialog_01 = '(DIALOG TITLE "%v_dialog_01_title%" WIDTH 526 HEIGHT 400 )'
v_dialog_01 = v_dialog_01 +' '+'(BUTTONSET TITLE "&OK;&Cancel" AT 420 276 DEFAULT 1 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_01%" AT 24 16 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_02%" AT 24 52 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_03%" AT 108 76 WIDTH 245 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_04%" AT 108 100 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_05%" AT 192 124 WIDTH 248 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_06%" AT 108 52 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_07%" AT 108 124 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_08%" AT 204 148 WIDTH 229 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_09%" AT 228 172 WIDTH 227 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_10%" AT 240 196 WIDTH 212 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_11%" AT 240 220 WIDTH 212 )'
v_dialog_01 = v_dialog_01 +' '+'(TEXT TITLE "%v_dialog_01_line_12%" AT 24 280 )'
v_dialog_01 = v_dialog_01 +' '+'(ITEM TITLE "C" TO "v_vaelg_felt" AT 120 276 WIDTH 235 )'


COM ----- DIALOG 1 ----- End -------

COM ------------ DIALOGS ----------------- End ----------------------------------------------




COMMENT ---- Slet midlertidig filer --- start ---
DELETE w55_sum_vaelg_felt.fil OK
DELETE FORMAT w55_sum_vaelg_felt OK
DELETE w55_sub_tabel_opdeling.bat OK
DELETE BATCH w55_sub_ot_felt2 OK
DELETE w55_sub_ot_felt2.bat OK
DELETE BATCH w55_div_ot_Felt_Ver_2_2 OK
DELETE w55_div_ot_Felt_Ver_2_2.bat OK
DELETE BATCH w55_div_ot_Felt_Ver_2_3 OK
DELETE w55_div_ot_Felt_Ver_2_3.bat OK
COMMENT ---- Slet midlertidig filer --- slut ---

COMMENT --- Slet midlertidige variabler ----- start ---
delete v_vaelg_felt ok
delete v_felt_indhold ok
delete V_tabel_nr ok
delete v_folder1_navn ok
delete v_tabel_fornavn ok
delete v_ind_tabel ok
delete v_antal_s ok
delete v_tabel_navn ok
delete v_Antal ok
delete v_last_record OK
delete v_first_record OK
delete v_folder2_navn ok
delete v_antal_gennemlb ok
delete v_batch_navn ok
delete v_batch_navn_bat ok
delete v_tabel_nr_z OK
COMMENT --- Slet midlertidige variabler ----- slut ---


DELETE BATCH w55_sub_tabel_opdeling OK
DELETE w55_Sub_tabel_opdeling.bat OK

COMMENT ---- Initialisering af variabler -----
V_tabel_nr=0
MAX1=0

COMMENT ---- Diverse variabler - information om tabel og felter -----
DO SCRIPT e_audit_GetACLandTableInfo
IF v_GetUserSetExactOnOff='OFF' SET EXACT ON

SET SAFETY OFF
SET ECHO NONE

COMMENT ---- Undersg om der tidligere er opdelt tabeller ----- start -----
DIR %v_foldername_abbrev%*.fil to w55_tmp_ot_tabelnr

OPEN w55_tmp_ot_tabelnr

STATISTICS ON VALUE(SPLIT(REVERSE(SPLIT(REVERSE( ALLTRIM( FILE_NAME)) '\' 1)) '_' 1) 0) if MAP(substr(ALLTRIM(REVERSE(SPLIT(REVERSE( ALLTRIM( FILE_NAME)) '\' 1))) 1 6) '%v_foldername_abbrev%99_') TO SCREEN NUMBER 5
COM STATISTICS ON VALUE(SPLIT(REVERSE(SPLIT(REVERSE( ALLTRIM( FILE_NAME)),'\',1)),'_',1),0) if MAP(substr(ALLTRIM(REVERSE(SPLIT(REVERSE( ALLTRIM( FILE_NAME)),'\',1))),1,6),'%v_foldername_abbrev%99_') TO SCREEN NUMBER 5


v_tabel_nr=MAX1+1

COMMENT ---- Slet midlertidig fil --- start ---
DELETE FORMAT w55_tmp_ot_tabelnr OK
DELETE w55_tmp_ot_tabelnr.fil OK
COMMENT ---- Slet midlertidig fil --- slut ---

COMMENT ---- Undersg om der tidligere er opdelt tabeller ----- slut -----


COMMENT ---- Vlg tabel -----

v_ind_tabel='%v_GetOpenTableName%'


v_tabel_nr_z=zoned(v_tabel_nr 2)
v_folder1_navn=Alltrim(Substr('%v_foldername_abbrev%'+'%v_tabel_nr_z%'+'_'+'%v_ind_tabel%' 1 31))
v_tabel_fornavn='%v_foldername_abbrev%'+'%v_tabel_nr_z%'

OPEN %v_ind_tabel%

COMMENT ---- Opret subscript ---- start --------
EXPORT ' LOCATE RECORD v_antal' FIRST 1 TO w55_sub_ot_felt2.bat
EXPORT ' v_felt_indhold=%v_vaelg_felt%' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
EXPORT ' v_antal_s=ZONED(v_antal 2)' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
EXPORT ' v_tabel_navn=ALLTRIM(REPLACE(include(lower(ALLTRIM(Replace(SUBSTR('+chr(39)+'%v_tabel_fornavn%'+chr(39)+'+'chr(39)+'_'+chr(39)+'+ALLTRIM('+chr(39)+'%v_felt_indhold%'+chr(39)+') 1 31) '+chr(39)+' '+chr(39)+' '+chr(39)+'_'+chr(39)+'))) '+chr(39)+'%v_valid_characters%'+chr(39)+') lower('+chr(39)+'%v_tabel_fornavn%'+chr(39)+') UPPER('+chr(39)+'%v_tabel_fornavn%'+chr(39)+')))' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
com EXPORT ' v_tabel_navn=ALLTRIM(REPLACE(include(lower(ALLTRIM(Replace(SUBSTR('+chr(39)+'%v_tabel_fornavn%'+chr(39)+'+'chr(39)+'_'+chr(39)+'+ALLTRIM('+chr(39)+'%v_felt_indhold%'+chr(39)+'),1,31),'+chr(39)+' '+chr(39)+','+chr(39)+'_'+chr(39)+'))),'+chr(39)+'abcdefghijklmnopqrstuvwxyz 0987654321_'+chr(39)+'),lower('+chr(39)+'%v_tabel_fornavn%'+chr(39)+'),UPPER('+chr(39)+'%v_tabel_fornavn%'+chr(39)+')))' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
EXPORT 'EXPORT '+ chr(34)+'EXTRACT ALL if %v_vaelg_felt%='+chr(39)+'%v_felt_indhold%'+chr(39)+' TO %v_tabel_navn%'+chr(34)+' if RECNO()=v_antal TO w55_sub_tabel_opdeling.bat APPEND' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
EXPORT 'v_Antal=v_Antal+1' FIRST 1 TO w55_sub_ot_felt2.bat APPEND
COMMENT ---- Opret subscript ---- slut --------

COMMENT ---- Vlg felt -----

DIALOG %v_dialog_01%


COMMENT ---- Opret folder til tabeller -----
v_folder2_navn=Alltrim(Substr('%v_foldername_abbrev%'+'%v_tabel_nr_z%'+'_'+'%v_vaelg_felt%' 1 31))
SET FOLDER /%v_foldername_top%
SET FOLDER /%v_foldername_top%/%v_folder1_navn%
SET FOLDER /%v_foldername_top%/%v_folder1_navn%/%v_folder2_navn%

COMMENT ----- Dan tabel med vrdier til opdeling - start --
SUMMARIZE ON %v_vaelg_felt% TO w55_sum_vaelg_felt OPEN PRESORT

COUNT
v_length_record=LENGTH(ALLTRIM(STRING(COUNT1 15)))

DEFINE FIELD v_tabel_navn COMPUTED ALLTRIM( REPLACE(include(lower(alltrim(replace(substr('%v_tabel_fornavn%_'+ZONED(RECNO() %v_length_record%)+'_'+ALLTRIM(%v_vaelg_felt%) 1 31) ' ' '_'))) '%v_valid_characters%') lower('%v_tabel_fornavn%') upper('%v_tabel_fornavn%')) ) 
COM DEFINE FIELD v_tabel_navn COMPUTED ALLTRIM( REPLACE(include(lower(alltrim(replace(substr('%v_tabel_fornavn%_'+ZONED(RECNO() %v_length_record%)+'_'+ALLTRIM(%v_vaelg_felt%) 1 31) ' ' '_'))),'abcdefghijklmnopqrstuvwxyz 0987654321_') lower('%v_tabel_fornavn%') upper('%v_tabel_fornavn%')) ) 

DEFINE FIELD Nyt_felt COMPUTED 

'EXTRACT ALL if '+'%v_vaelg_felt%'+'='+chr(34)+%v_vaelg_felt%+chr(34)+' TO '+v_tabel_navn IF FIND(chr(39) %v_vaelg_Felt%)
'EXTRACT ALL if '+'%v_vaelg_felt%'+'='+chr(39)+%v_vaelg_felt%+chr(39)+' TO '+v_tabel_navn



COMMENT ----- Dan tabel med vrdier til opdeling - slut --


COMMENT ---- Undersg om der er mere end 40 kombinationer -----
v_antal_gennemlb=VALUE('0'+'%v_GetDecimalSymbol%'+'000000000' 9)
com v_antal_gennemlb=0.000000000
com v_antal_gennemlb=DEC((COUNT1+0.000000000)/40 9)
v_antal_gennemlb=DEC((COUNT1+v_antal_gennemlb)/40 9)
if v_antal_gennemlb>int(v_antal_gennemlb) v_antal_gennemlb=int(v_antal_gennemlb)+1

COMMENT ---- Opret subscript - w55_sub_tabel_opdeling - start ---

COMMENT ---- Opret subscript - w55_div_ot_Felt_Ver_2_2 - slut ---

EXPORT "v_first_record=v_last_record+1" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat
EXPORT "v_last_record=v_first_record+40" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND
EXPORT "v_batch_navn=ALLTRIM(replace('w55_sub_tabel_opdel_'+ZONED(v_antal %"+"v_length_record"+"%) ' ' '_'))" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND
EXPORT "v_batch_navn_bat='%"+"v_batch_navn"+"%'+'.bat'" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND

EXPORT "EXPORT 'DELETE BATCH '+'%"+"v_batch_navn"+"%'+' OK' FIRST 1 TO %"+"v_batch_navn_bat"+"%" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND
EXPORT "EXPORT 'GROUP' FIRST 1 TO %"+"v_batch_navn_bat"+"% APPEND" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND

EXPORT "EXPORT FIELDS Nyt_felt TO %"+"v_batch_navn_bat"+"% if BETWEEN(RECNO() v_first_record v_last_record) APPEND" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND

EXPORT "EXPORT 'END' FIRST 1 TO %"+"v_batch_navn_bat"+"% APPEND" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND
EXPORT "v_antal=v_antal+1" FIRST 1 TO W55_DIV_OT_FELT_ver_2_2.bat APPEND

COMMENT ---- Opret subscript - w55_div_ot_Felt_Ver_2_2 - slut ---

v_last_record=0
v_antal=1
do W55_DIV_OT_FELT_ver_2_2.bat while v_antal<=v_antal_gennemlb

COMMENT ---- Opret subscript - w55_sub_tabel_opdeling - slut ---


COMMENT ---- Opret subscript - w55_div_ot_Felt_Ver_2_3 - start ---

EXPORT "v_batch_navn=ALLTRIM(replace('w55_sub_tabel_opdel_'+ZONED(v_antal %"+"v_length_record"+"%) ' ' '_'))+'.bat'" FIRST 1 TO W55_DIV_OT_FELT_ver_2_3.bat
EXPORT "DO %"+"v_batch_navn"+"%" FIRST 1 TO W55_DIV_OT_FELT_ver_2_3.bat APPEND
EXPORT "v_antal=v_antal+1" FIRST 1 TO W55_DIV_OT_FELT_ver_2_3.bat APPEND
EXPORT "DELETE %"+"v_batch_navn"+"% OK" FIRST 1 TO W55_DIV_OT_FELT_ver_2_3.bat APPEND

COMMENT ---- Opret subscript - w55_div_ot_Felt_Ver_2_3 - start ---


OPEN %v_ind_tabel%

v_antal=1
DO w55_div_ot_felt_Ver_2_3.bat while v_antal<=v_antal_gennemlb

SET FOLDER /

Pause "%v_pause_line_01% /%v_foldername_top%/%v_folder1_navn%/%v_folder2_navn%"

COMMENT ------ DELETE WRITE 2-40 variables ---- BEGIN -----
EXPORT "v_writenumber='WRITE'+ALLTRIM(STRING(v_count 2))" FIRST 1 to w55_del_write2.bat APPEND
EXPORT "EXPORT 'DELETE %v_writenumber% OK' FIRST 1 to w55_del_write.bat APPEND" FIRST 1 to w55_del_write2.bat APPEND
EXPORT "v_count=v_count+1" FIRST 1 to w55_del_write2.bat APPEND

v_count=2
DO SCRIPT w55_del_write2 WHILE v_count<=40
DO SCRIPT w55_del_write

DELETE v_count OK
DELETE v_writenumber OK
DELETE SCRIPT w55_del_write2 OK
DELETE w55_del_write2.bat OK
DELETE SCRIPT w55_del_write OK
DELETE w55_del_write.bat OK

COMMENT ------ DELETE WRITE 2-40 variables ---- END -----




COMMENT ---- Slet midlertidig filer --- start ---
DELETE w55_sum_vaelg_felt.fil OK
DELETE FORMAT w55_sum_vaelg_felt OK
DELETE w55_sub_tabel_opdeling.bat OK
DELETE BATCH w55_sub_ot_felt2 OK
DELETE w55_sub_ot_felt2.bat OK
DELETE BATCH w55_div_ot_Felt_Ver_2_2 OK
DELETE w55_div_ot_Felt_Ver_2_2.bat OK
DELETE BATCH w55_div_ot_Felt_Ver_2_3 OK
DELETE w55_div_ot_Felt_Ver_2_3.bat OK
COMMENT ---- Slet midlertidig filer --- slut ---

COMMENT --- Slet midlertidige variabler ----- start ---
delete v_vaelg_felt ok
delete v_felt_indhold ok
delete V_tabel_nr ok
delete v_folder1_navn ok
delete v_tabel_fornavn ok
delete v_ind_tabel ok
delete v_antal_s ok
delete v_tabel_navn ok
delete v_Antal ok
delete v_last_record OK
delete v_first_record OK
delete v_folder2_navn ok
delete v_antal_gennemlb ok
delete v_batch_navn ok
delete v_batch_navn_bat ok
delete v_tabel_nr_z OK
DELETE v_length_record OK

DELETE v_foldername_abbrev OK
DELETE v_foldername_top OK

DELETE v_default_language OK
DELETE v_valid_characters OK
DELETE v_dialog_01_title OK
DELETE v_dialog_01_line_01 OK
DELETE v_dialog_01_line_02 OK
DELETE v_dialog_01_line_03 OK
DELETE v_dialog_01_line_04 OK
DELETE v_dialog_01_line_05 OK
DELETE v_dialog_01_line_06 OK
DELETE v_dialog_01_line_07 OK
DELETE v_dialog_01_line_08 OK
DELETE v_dialog_01_line_09 OK
DELETE v_dialog_01_line_10 OK
DELETE v_dialog_01_line_11 OK
DELETE v_dialog_01_line_12 OK
DELETE v_pause_line_01 OK
DELETE v_dialog_01 OK
DELETE v_dialog_02 OK

DELETE w55_tmp_log.log OK


COMMENT --- Slet diverse variabler om tabel og felter -----
SET EXACT %v_GetUserSetExactOnOff%

DO SCRIPT e_audit_DEL_GetACLandTableInfo

COMMENT --- Slet midlertidige variabler ----- slut ---



SET ECHO ON
SET SAFETY ON
