COMMENT
COMMENT
COMMENT
COMMENT 
*********** ENGLISH ********************* GENEREL INFORMATION ABOUT THE SCRIPT ********************************
* 
 Description:   The script extract amounts outside the standard deviation limits per accountnumber or another field.
*
 Version:       ACL version 9.2.1.
*
 Purpose:       The purpose of the script is:
                - to find amounts per account beyond the standard deviation limits (average +/- standard deviation).
*
 Preconditions: English version of ACL.
*
 Input:         Screen dialog.
                - choose field - example accountnumber.
                - choose amount
                - write new tablename.
*
 Output:        New table with amounts outside standard deviation limits.
*
*
 Date:          Developed: 2011-09-26
                Updated  : 2011-09-26 Version 1.0
*
 Version:       1.0
*
 Developer:     Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:     The script is made to help auditors/ACL users in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
END


COMMENT 
*********** DANISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
 Beskrivelse:   Scriptet laver extract af belb uden for standardafvigelse pr. konto eller andet felt.
*
 Version:       ACL version 9.2.1
*
 Forml:        Forml med scriptet er:
                - at finde belb pr konto som er udenfor standard afvigelses grnserne (gennemsnit +/- standardafvigelse).
*
 Forudstning:  Engelske version af ACL.
*
 Input:         Skrmdialog.
                - vlg felt - eksempel - kontonummer
                - vlg belb
                - skriv nyt tabelnavn
*
 Output:        Ny tabel med belb uden standardafvigelsens grnser.
*
*
 Applications:  Scriptet er placeret under 06 ANALYSE.
*
 Dato:          Udviklet:  2011-09-26
                Opdateret: 2011-09-26 Version 1.0
*
 Version:       1.0
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055. Email: erling.petersen@skat.dk
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
END


COMMENT *************************** SCRIPT START ************************************************


SET ECHO NONE
SET SAFETY OFF

DELETE SCRIPT e_audit_STD_DEV_PER_ACCOUNT OK


COM ----- BEGIN ----------- Get ACL and Table Information -----------------
  DO SCRIPT e_audit_GetACLandTableInfo
  IF v_GetUserSetExactOnOff='ON' SET EXACT OFF
COM ----- END ------------- Get ACL and Table Information -----------------



COMMENT --- BEGIN ---------- Dialog 2 (first one)--------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_02_title      ='STANDARD DEVIATION'

IF v_default_language='EN' v_dialog_02_line_01    ='FINDS STANDARD DEVIATION - AVERAGE +/- ACLs STANDARD DEVIATION'
IF v_default_language='EN' v_dialog_02_line_02    ='Standard deviation'
COMMENT --- End -- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_02_title      ='STANDARDAFVIGELSE'

IF v_default_language='DA' v_dialog_02_line_01    ='FINDER STANDARD AFVIGELSER - GENNEMSNIT +/- ACLs STANDARDAFVIGELSE'
IF v_default_language='DA' v_dialog_02_line_02    ='Standardafvigelse'
COMMENT --- End -- DA -----

COMMENT --- END ------------ Dialog 2 (first one)--------------------------------------


COMMENT --- BEGIN ---------- Dialog 1 (second one)--------------------------------------

COMMENT --- Begin -- EN -----
IF v_default_language='EN' v_dialog_01_title      ='Standard devation per account'

IF v_default_language='EN' v_dialog_01_line_01    ='Information:'
IF v_default_language='EN' v_dialog_01_line_02    ='The script finds transactions that deviate from the standard per account (or another field).'
IF v_default_language='EN' v_dialog_01_line_03    ='Preconditions:'
IF v_default_language='EN' v_dialog_01_line_04    ='Table with accountnumber (or another field).'
IF v_default_language='EN' v_dialog_01_line_05    ='Output:'
IF v_default_language='EN' v_dialog_01_line_06    ='Table with transactions outside the standard deviations per account (or another field.)'
IF v_default_language='EN' v_dialog_01_line_07    ='Choose field with account number (or another field):'
IF v_default_language='EN' v_dialog_01_line_08    ='Choose field with amount:'
IF v_default_language='EN' v_dialog_01_line_09    ='The result will be written to a new table.'
IF v_default_language='EN' v_dialog_01_line_10    ='Please write a name for the new table:'
COMMENT --- End -- EN -----

COMMENT --- Begin -- DA -----
IF v_default_language='DA' v_dialog_01_title      ='Standardafvigelse pr. konto'

IF v_default_language='DA' v_dialog_01_line_01    ='Information:'
IF v_default_language='DA' v_dialog_01_line_02    ='Scriptet finder transaktioner som afviger fra standarden pr. konto (eller andet felt).'
IF v_default_language='DA' v_dialog_01_line_03    ='Forudstninger:'
IF v_default_language='DA' v_dialog_01_line_04    ='Tabel med kontonummer (eller andet felt).'
IF v_default_language='DA' v_dialog_01_line_05    ='Uddata:'
IF v_default_language='DA' v_dialog_01_line_06    ='Tabel med transaktioner som afviger fra standarden pr. konto (eller andet felt).'
IF v_default_language='DA' v_dialog_01_line_07    ='Vlg felt med kontonummer (eller et andet felt):'
IF v_default_language='DA' v_dialog_01_line_08    ='Vlg felt med belb:'
IF v_default_language='DA' v_dialog_01_line_09    ='Resultatet vil blive skrevet til en ny tabel.'
IF v_default_language='DA' v_dialog_01_line_10    ='Skriv et navn til den nye tabel:'
COMMENT --- End -- DA -----

COMMENT --- END ------------ Dialog 2 (second one)--------------------------------------



COM ----- BEGIN ------------- Make temporary format ----
  DIR C:\w55.* TO TMP_C_DREV
  OPEN TMP_C_DREV
  EXTRACT BLANKS(250) AS 'TMP_LINE' FIRST 1 to TMP_FORMAT_250
COM ----- END --------------- Make temporary format ----


COM ----- BEGIN ------------- Open table ----
  OPEN %v_GetOpenTableName%
COM ----- END --------------- Open table ----


COM ----- BEGIN ----------- Create subscript - w55_dialog_02.bat ----------------
  EXPORT '   v_from_left=v_from_left-6                                                                                                                                       ' FIRST 1 TO w55_dialog_02.bat
  EXPORT '   v_from_top=v_from_top+14                                                                                                                                        ' FIRST 1 TO w55_dialog_02.bat APPEND
  EXPORT '   v_count_dialog_plus=v_count_dialog_02*2                                                                                                                         ' FIRST 1 TO w55_dialog_02.bat APPEND
  EXPORT '   v_dialog_02_plus=chr(34)+REPEAT("+" %v_count_dialog_plus%)+chr(34)                                                                                              ' FIRST 1 TO w55_dialog_02.bat APPEND
  EXPORT "   v_dialog_02_02=ALLTRIM('%v_dialog_02_02%')+' (TEXT TITLE '+'%v_dialog_02_plus%'+' AT '+ALLTRIM(STRING(v_from_left 12))+' '+ALLTRIM(STRING(v_from_top 12))+' )'  " FIRST 1 TO w55_dialog_02.bat APPEND
  EXPORT '   v_count_dialog_02=v_count_dialog_02+1                                                                                                                           ' FIRST 1 TO w55_dialog_02.bat APPEND
COM ----- END ------------- Create subscript - w55_dialog_02.bat ----------------


COM ----- BEGIN ----------- Make start dialog ----------------
  v_dialog_02_02=''
  v_from_left=250
  v_from_top=30
  v_count_dialog_02=1
  v_dialog_02_plus=''
  DO w55_dialog_02 while v_count_dialog_02<=20

  v_dialog_02_01=BLANKS(2000)
  v_dialog_02_01='  (DIALOG TITLE "%v_dialog_02_title%" WIDTH 610 HEIGHT 395 ) '
  v_dialog_02_01=v_dialog_02_01+' (BUTTONSET TITLE "&OK;&Cancel" AT 500 340 DEFAULT 1 ) '

  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "%v_dialog_02_line_01%" AT 60 15 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 50 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 70 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 90 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 110 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 130 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 150 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 330 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 350 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 156 370 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 82 120 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 82 135 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "V" AT 80 150 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "%v_dialog_02_line_02%" AT 30 92 )'
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 50 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 70 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 90 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 110 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 130 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 150 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 330 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 350 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 345 370 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 422 120 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "|" AT 422 135 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "V" AT 420 150 ) '
  v_dialog_02_01=v_dialog_02_01+' (TEXT TITLE "%v_dialog_02_line_02%" AT 380 92 )'
  v_dialog_02_01=v_dialog_02_01+' %v_dialog_02_02%'

  DIALOG %v_dialog_02_01%

  DELETE SCRIPT w55_dialog_02 OK
  DELETE w55_dialog_02.bat OK
  DELETE v_dialog_02_01 OK
  DELETE v_dialog_02_02 OK
  DELETE v_from_left OK
  DELETE v_from_top OK
  DELETE v_count_dialog_02 OK
  DELETE v_dialog_02_plus OK
  DELETE v_count_dialog_plus OK
  DELETE v_dialog_02_title OK
  DELETE v_dialog_02_line_01 OK
  DELETE v_dialog_02_line_02 OK

COM ----- END ------------- Make start dialog ----------------


COM ----- BEGIN ----------- Build dialogbox for input -----------------
  v_dialog_01='(DIALOG TITLE "%v_dialog_01_title%" WIDTH 723 HEIGHT 351 ) '
  v_dialog_01=v_dialog_01+'(BUTTONSET TITLE "&OK;&Cancel" AT 624 276 DEFAULT 1 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_01%" AT 24 28 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_02%" AT 144 28 WIDTH 478 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_03%" AT 24 76 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_04%" AT 144 76 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_05%" AT 24 100 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_06%" AT 144 100 WIDTH 445 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_07%" AT 48 148 WIDTH 257 ) '
  v_dialog_01=v_dialog_01+'(ITEM TITLE "CN" TO "v_account" AT 336 144 WIDTH 269 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_08%" AT 48 196 ) '
  v_dialog_01=v_dialog_01+'(ITEM TITLE "N" TO "v_amount" AT 336 192 WIDTH 269 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_09%" AT 48 256 ) '
  v_dialog_01=v_dialog_01+'(TEXT TITLE "%v_dialog_01_line_10%" AT 48 280 ) '
  v_dialog_01=v_dialog_01+'(EDIT TO "v_new_table_name" AT 336 276 WIDTH 269 ) '

  DIALOG %v_dialog_01%

  DELETE v_dialog_01 OK
  DELETE v_dialog_01_title OK
  DELETE v_dialog_01_line_01 OK
  DELETE v_dialog_01_line_02 OK
  DELETE v_dialog_01_line_03 OK
  DELETE v_dialog_01_line_04 OK
  DELETE v_dialog_01_line_05 OK
  DELETE v_dialog_01_line_06 OK
  DELETE v_dialog_01_line_07 OK
  DELETE v_dialog_01_line_08 OK
  DELETE v_dialog_01_line_09 OK
  DELETE v_dialog_01_line_10 OK
COM ----- END ------------- Build dialogbox for input-----------------


COM ----- BEGIN ------------- New table name with valid characters ----
  v_new_table_name=ALLTRIM(SUBSTR(ALLTRIM(REPLACE(INCLUDE(v_new_table_name '%v_valid_characters%') ' ' '_')) 1 31))
COM ----- END --------------- New table name with valid characters ----


COM ----- BEGIN ----------- Sum per characterfield and create script line -----------------
  v_type=FTYPE(v_account)
  IF FTYPE(v_account)="C" SUMMARIZE ON %v_account% TO w55_sum_v_account PRESORT OPEN
  IF FTYPE(v_account)="N" SUMMARIZE ON ALLTRIM(STRING(%v_account% 15)) AS '%v_account%' TO w55_sum_v_account PRESORT OPEN
  v_number_of_v_account=WRITE1

  IF v_type="N"   DEFINE FIELD account_std_text COMPUTED 'STATISTICS ON '+'%v_amount%'+' IF '+'%v_account%'+' = '+%v_account%+' STD TO SCREEN NUMBER 1'
  IF v_type="C"   DEFINE FIELD account_std_text COMPUTED 'STATISTICS ON '+'%v_amount%'+' IF '+'%v_account%'+' = "'+%v_account%+'" STD TO SCREEN NUMBER 1'
  IF v_type="C"   v_fieldlength=LENGTH(%v_account%)
  IF v_type="N"   v_fieldlength=0
COM ----- END ------------- Sum per characterfield and create script line -----------------


COM ----- BEGIN ----------- Calculate number of loop -----------------
  if MOD(v_number_of_v_account 40)<>0 v_loop_max=INT(DEC(v_number_of_v_account 5)/40)+1
  if MOD(v_number_of_v_account 40)=0 v_loop_max=INT(DEC(v_number_of_v_account 5)/40)
  v_loop_count=1
  v_min_start=1
  IF v_number_of_v_account>=40 v_max_end=40
  IF v_number_of_v_account<40 v_max_end=v_number_of_v_account
COM ----- END ------------- Calculate number of loop -----------------


COM ----- BEGIN ----------- Create subscript - w55_create_sub_script ----------------
   EXPORT '    v_tmp_script_number="w55_sub_group"+ZONED(v_loop_count 3)+".bat"                                            ' FIRST 1 TO w55_create_sub_script.bat
   EXPORT '    EXPORT "GROUP" FIRST 1 TO %'+'v_tmp_script_number'+'%                                                       ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    EXPORT account_std_text IF BETWEEN(RECNO()  v_min_start  v_max_end) TO %'+'v_tmp_script_number'+'% APPEND   ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    EXPORT "END" FIRST 1 TO %'+'v_tmp_script_number'+'% APPEND                                                  ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    v_loop_count=v_loop_count+1                                                                                 ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    v_min_start=v_max_end+1                                                                                     ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    IF v_number_of_v_account> 40*v_loop_count v_max_end=40*v_loop_count                                         ' FIRST 1 TO w55_create_sub_script.bat APPEND
   EXPORT '    IF v_number_of_v_account<=40*v_loop_count v_max_end=v_number_of_v_account                                   ' FIRST 1 TO w55_create_sub_script.bat APPEND
COM ----- BEGIN ----------- Create subscript - w55_create_sub_script ----------------


COM ----- BEGIN ----------- Run subscript - w55_create_sub_script ----------------
  DO SCRIPT w55_create_sub_script WHILE v_loop_count<=v_loop_max
COM ----- END ------------- Run subscript - w55_create_sub_script ----------------


COM ----- BEGIN ----------- Delete subscript - w55_create_sub_script ----------------
  DELETE SCRIPT w55_create_sub_script OK
  DELETE w55_create_sub_script.bat OK
COM ----- END ------------- Delete subscript - w55_create_sub_script ----------------


OPEN %v_GetOpenTableName%


COM ----- BEGIN ----------- Create subscript - w55_create_sub_acc_amount ----------------
   EXPORT "  LOCATE RECORD  v_loop_count                                                                                     "  FIRST 1 TO w55_create_sub_acc_amount.bat 
   EXPORT "  v_account_number=SUBSTR(TMP_LINE  AT(1 '=' TMP_LINE)+1 AT(1 'STD TO SCREEN' TMP_LINE)-AT(1 '=' TMP_LINE)-1)     "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  v_tmp_STD_text='STDDEV'+ALLTRIM(STRING(v_loop_count 12))                                                        "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  v_tmp_STD_text_n=%"+"v_tmp_STD_text"+"%                                                                         "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  v_tmp_AVG_text='AVERAGE'+ALLTRIM(STRING(v_loop_count 12))                                                       "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  v_tmp_AVG_text_n=%"+"v_tmp_AVG_text"+"%                                                                         "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  EXPORT FIELDS v_account_number '#' v_tmp_STD_text_n '#' v_tmp_AVG_text_n FIRST 1 to w55_rel_file APPEND         "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
   EXPORT "  v_loop_count=v_loop_count+1                                                                                     "  FIRST 1 TO w55_create_sub_acc_amount.bat APPEND
COM ----- END ------------- Create subscript - w55_create_sub_acc_amount ----------------


COM ----- BEGIN ----------- Create subscript - w55_create_deviation_file ----------------
   EXPORT "  OPEN %"+"v_GetOpenTableName"+"%                                                             " FIRST 1 to w55_create_deviation_file.bat

   EXPORT "  v_script_name='w55_sub_group'+ZONED(v_loop_sub_script_count 3)+'.bat'                       " FIRST 1 to w55_create_deviation_file.bat APPEND

   EXPORT "  DO %"+"v_script_name"+"%                                                                    " FIRST 1 to w55_create_deviation_file.bat APPEND

   EXPORT "  OPEN %"+"v_script_name"+"% FORMAT TMP_FORMAT_250 CRLF                                       " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  COUNT                                                                                       " FIRST 1 to w55_create_deviation_file.bat APPEND

   EXPORT "  COM ----- BEGIN ----------- Run subscript - w55_create_sub_acc_amount ----------------      " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  v_stddev_loop=1                                                                             " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  v_loop_count=2                                                                              " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  DO w55_create_sub_acc_amount WHILE v_loop_count<=COUNT1-1                                   " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  COM ----- END ------------- Run subscript - w55_create_sub_acc_amount ----------------      " FIRST 1 to w55_create_deviation_file.bat APPEND

   EXPORT "  COM ----- BEGIN ----------- Delete subscript - w55_create_sub_acc_amount ----------------   " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  CLOSE                                                                                       " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  v_script_name_without_bat=ALLTRIM(REPLACE('%"+"v_script_name"+"%' '.bat' ''))               " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  DELETE SCRIPT %"+"v_script_name_without_bat"+"% OK                                          " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  DELETE %"+"v_script_name"+"% OK                                                             " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  DELETE v_script_name_without_bat OK                                                         " FIRST 1 to w55_create_deviation_file.bat APPEND
   EXPORT "  COM ----- END ------------- Delete subscript - w55_create_sub_acc_amount ----------------   " FIRST 1 to w55_create_deviation_file.bat APPEND

   EXPORT "  v_loop_sub_script_count=v_loop_sub_script_count+1                                           " FIRST 1 to w55_create_deviation_file.bat APPEND
COM ----- END ------------- Create subscript - w55_create_deviation_file ----------------


COM ----- BEGIN ----------- Run subscript - w55_create_deviation_file ----------------
  v_account_number=BLANKS(250)
  v_loop_sub_script_count=1

  DO w55_create_deviation_file.bat WHILE v_loop_sub_script_count<=v_loop_max
COM ----- END ------------- Run subscript - w55_create_deviation_file ----------------


COM ----- BEGIN ----------- Delete subscript - w55_create_sub_acc_amount ----------------
  DELETE SCRIPT w55_create_sub_acc_amount OK
  DELETE w55_create_sub_acc_amount.bat OK
COM ----- END ------------- Delete subscript - w55_create_sub_acc_amount ----------------


COM ----- BEGIN ----------- Delete subscript - w55_create_deviation_file ----------------
  DELETE SCRIPT w55_create_deviation_file OK
  DELETE w55_create_deviation_file.bat OK
COM ----- END ------------- Delete subscript - w55_create_deviation_file ----------------


OPEN %v_GetOpenTableName%


COM ----- BEGIN ----------- Create subscript - w55_delete_std_variables ----------------
   EXPORT "   v_var_name='COUNT'+ALLTRIM(STRING(v_loop_del_var 2))                    " FIRST 1 TO w55_delete_std_variables.bat
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='LOW'+ALLTRIM(STRING(v_loop_del_var 2))                      " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='HIGH'+ALLTRIM(STRING(v_loop_del_var 2))                     " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='RANGE'+ALLTRIM(STRING(v_loop_del_var 2))                    " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='STDDEV'+ALLTRIM(STRING(v_loop_del_var 2))                   " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='ABS'+ALLTRIM(STRING(v_loop_del_var 2))                      " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='AVERAGE'+ALLTRIM(STRING(v_loop_del_var 2))                  " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='MIN'+ALLTRIM(STRING(v_loop_del_var 2))                      " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='MAX'+ALLTRIM(STRING(v_loop_del_var 2))                      " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_var_name='TOTAL'+ALLTRIM(STRING(v_loop_del_var 2))                    " FIRST 1 TO w55_delete_std_variables.bat APPEND
   EXPORT "   DELETE %"+"v_var_name"+"% OK                                            " FIRST 1 TO w55_delete_std_variables.bat APPEND

   EXPORT "   v_loop_del_var=v_loop_del_var+1                                         " FIRST 1 TO w55_delete_std_variables.bat APPEND
COM ----- END ------------- Create subscript - w55_delete_std_variables ----------------


COM ----- BEGIN ----------- Run subscript - w55_delete_std_variables ----------------
  v_loop_del_var=2
  DO w55_delete_std_variables.bat while v_loop_del_var<=41
COM ----- END ------------- Run subscript - w55_delete_std_variables ----------------


COM ----- BEGIN ----------- Delete subscript - w55_delete_std_variables ----------------
  DELETE SCRIPT w55_delete_std_variables OK
  DELETE w55_delete_std_variables.bat OK
COM ----- END ------------- Delete subscript - w55_delete_std_variables ----------------


COM ----- BEGIN ----------- Define relationskey and STD DEVIATION ----------------
  OPEN w55_rel_file.txt FORMAT TMP_FORMAT_250 CRLF

  if v_type ='N' and OCCURS(TMP_LINE '.')=2 DEFINE FIELD %v_account% NUMERIC 2 12 0
  if v_type ='N' and OCCURS(TMP_LINE '.')=3 DEFINE FIELD %v_account% NUMERIC 2 15 2

  if v_type <>'N' DEFINE FIELD %v_account% COMPUTED SUBSTR(TMP_LINE 3 %v_fieldlength%)

  DEFINE FIELD w55_STD_FIELD COMPUTED VALUE(SPLIT(TMP_LINE '#' 2) 2)
  DEFINE FIELD w55_AVERAGE_FIELD COMPUTED VALUE(SPLIT(TMP_LINE '#' 3) 2)

  EXTRACT FIELDS %v_account% w55_STD_FIELD w55_AVERAGE_FIELD TO w55_join_std_dev OPEN
COM ----- END ------------- Define relationskey and STD DEVIATION ----------------



COM ----- BEGIN ----------- RELATE and EXTRACT deviations from original table ----------------
  OPEN %v_GetOpenTableName%

  OPEN SECONDARY  w55_join_std_dev
  JOIN PKEY %v_account% FIELDS ALL SKEY %v_account% WITH w55_STD_FIELD w55_AVERAGE_FIELD PRIMARY TO "w55_j_original_std_avg" OPEN PRESORT SECSORT

  EXTRACT ALL IF %v_amount% >= w55_AVERAGE_FIELD + ABS(w55_STD_FIELD) OR %v_amount% <= w55_AVERAGE_FIELD - ABS(w55_STD_FIELD) TO %v_new_table_name% OPEN

  CLOSE SECONDARY

  DELETE FIELD w55_STD_FIELD OK
  DELETE FIELD w55_AVERAGE_FIELD OK

  DELETE FORMAT  w55_j_original_std_avg OK
  DELETE w55_j_original_std_avg.fil OK

  DELETE FORMAT  w55_join_std_dev OK
  DELETE w55_join_std_dev.fil OK
COM ----- END ------------- RELATE and EXTRACT deviations from original table ----------------


COM ----- BEGIN ----------- Delete temp files and variables ----------------
  OPEN TMP_FORMAT_250.fil FORMAT TMP_FORMAT_250 CRLF
  CLOSE

  DELETE FORMAT TMP_FORMAT_250 OK
  DELETE TMP_FORMAT_250.fil OK

  DELETE FORMAT TMP_C_DREV OK
  DELETE TMP_C_DREV.fil OK

  DELETE FORMAT w55_sum_v_account OK
  DELETE w55_sum_v_account OK

  DELETE w55_rel_file.txt OK

  DELETE v_loop_del_var OK
  DELETE v_var_name OK
  DELETE v_loop_sub_script_count OK
  DELETE v_loop_count OK
  DELETE v_tmp_AVG_text_n OK
  DELETE v_tmp_AVG_text OK
  DELETE v_tmp_STD_text_n OK
  DELETE v_tmp_STD_text OK
  DELETE v_account_number OK
  DELETE v_stddev_loop OK
  DELETE v_script_name OK
  DELETE v_max_end OK
  DELETE v_min_start OK
  DELETE v_tmp_script_number OK
  DELETE v_loop_max OK
  DELETE v_fieldlength OK
  DELETE v_number_of_v_account OK
  DELETE v_type OK
  DELETE v_amount OK
  DELETE v_account OK
COM ----- END ------------- Delete temp files and variables ----------------


COM ----- BEGIN ----------- Return user settings EXACT ON/OFF ----------------
  SET EXACT %v_GetUserSetExactOnOff%
COM ----- END ------------- Return user settings EXACT ON/OFF ----------------


COM ----- BEGIN ----------- Delete GetACLandTableInfo variables ----------------
  DO SCRIPT e_audit_DEL_GetACLandTableInfo
COM ----- END ------------- Delete GetACLandTableInfo variables ----------------


COM ----- BEGIN ------------- Open created table and delete variable ----
  OPEN %v_new_table_name%

  DELETE v_new_table_name OK
COM ----- END --------------- Open created table and delete variable ----




SET SAFETY ON
SET ECHO ON
