******************************** GENEREL INFORMATION OM SCRIPTET ********************************
*
COMMENT
COMMENT
COMMENT 
******************************** GENEREL INFORMATION OM SCRIPTET ********************************
*
 Beskrivelse:   Analyse af indholdet i felter i en tabel
*
 Forml:        Forml med scriptet er:
                At f et overblik over indholdet i felterne i en tabel. Der er brugt CLASSIFY til karakterfelter (max. 63 karakterer)
*
 Forudstning:  Adgang til en tabel med feltindhold
*
 Input:         Tabelnavn, hvis der ikke er nogen ben tabel.
*
 Output:        Folder med TABEL_ANALYSE\TAnn_TABELNAVN\
                Under folder bliver oprettet en tabel med hvert feltnavn TAnn_FELTNAVN
*
 Applications:  06 Analyser
*
 Dato:          Udviklet:  v 1.0   2010-01-28 (w00055, Tabelanalyse af karakter og numeriske felter. Begrnsning p 45 felter)
                Opdateret: v 1.1   2010-08-09 (W00055, Opdateret - fra karakter og numeriske til alle felttyper) 
                           v 1.1.1 2010-08-17 (W00055, Tekst ndret)
                           v 1.2   2010-08-18 (W00055, Tilpasset feltlngde p 31 karakterer - nr bliver evt. tilfjet, hvis feltnavn er strre end 31 karakterer))
                           v 1.2.1 2010-08-19 (w00055, Default_View tilpasset til feltindhold)
                           v 1.3   2010-08-23 (W00055, Begrnsning p 45 felter ophvet)
                           v 1.3.1 2010-08-24 (W00055, Slet alle temp filer)
                           v 1.3.2 2010-08-26 (W00055, Engelsk og dansk i samme version)
                           v 1.3.3 2010-08-30 (W00055, Problem med belbskonvertering - rettet)
                           v 1.3.4 2010-08-30 (W00055, Slut tekst ndret)
                           v 1.3.5 2010-09-21 (w00055, ndret s man ikke fr fejl, nr feltnavnet er tildelt det reserverede bogstav a)
                           v 1.3.6 2011-01-23 (w00055, ndret s man ogs fr feltnavne med, der starter med a)
                           v 1.3.7 2011-05-17 (w00055, ndret s man ikke bliver spurgt om at bne en tabel, der allerede er ben.)
                           v 2.0   2011-11-21 (w00055, Ingen fast interval i belbsfelter. Mulighed for at anvende andre sprog. Krer med alle feltseparatoere.)
*
 Version:       2.0
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055.
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
*
 Beskrivelse:   1. Undersg om der tidligere har vre foretaget tabelanalyse.
                2. Opret ny folder med nummer for den nye tabelanalyse.
                3. Opret diverse subscript.
                4. Dan script til CLASSIFY p CHARACTER, DATE og LOGICAL felter og STRATIFY p NUMERIC felter.
                5. Opdel script i subscript (bliver brugt hvis antal af felter er strre end 40 - GROUP begrnsning).
                6. Dan en tabel med indholdet i hvert felt (CLASSIFY p CHARACTER, DATE og LOGICAL felter og STRATIFY p NUMERIC felter).
                6. Tilpas Default_View til indhold i felter eller feltnavn
END




COMMENT 
******************************** GENEREL INFORMATION ABOUT THE SCRIPT ********************************
*
 Description:   Analyze the content of the fields in the table.
*
 Purpose:       The purpose of the script is:
                To get an overview of the content of the fields in a tbale. CLASSIFY is used on characterfields (max. 63 characters).                
*
 Precondition:  Access to a table with fields
*
 Input:         Tablename, if no table is open.
*
 Output:        Folder with TABLE_ANALYSIS\TAnn_tablename\
                Below the folder will be createt a table with every fieldname - TAnn_fieldname.
*
 Applications:  
*
 Dato:          Developed: v 1.0   2010-01-28 (w00055, Tableanalyze of character and numeric fields (limit on 45 fields)
                Opdateret: v 1.1   2010-08-09 (W00055, Alle fieldtypes) 
                           v 1.1.1 2010-08-17 (W00055, Text changed)
                           v 1.2   2010-08-18 (W00055, Adjust table name on 31 characters - number added))
                           v 1.2.1 2010-08-19 (w00055, Default_View adjusted to field content)
                           v 1.3   2010-08-23 (W00055, Limitations on 45 field removed)
                           v 1.3.1 2010-08-24 (W00055, Delete all temp files)
                           v 1.3.2 2010-08-26 (W00055, Engelsk and Danish in the same verion)
                           v 1.3.3 2010-08-30 (W00055, Problems with converting amount - solved)
                           v 1.3.4 2010-08-30 (W00055, End text changed)
                           v 1.3.5 2010-09-21 (w00055, Change - no error when using the reserved letter a)
                           v 1.3.6 2011-01-23 (w00055, Change - fieldnames starting with a)
                           v 1.3.7 2011-05-17 (w00055, Change - don't ask if a table is already open.)
                           v 2.0   2011-11-04 (w00055, No fixed interval on numeric fields. All field separators. Possible to change language with the script Func_v_GetLanguage.)
*
 Version:       2.0
*
 Developed by:  Workinggroup: Scripts
                Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:     The script is made to help Danish ACL users in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used. *
*
 Description:   1. Examin if the script has been run before.
                2. Create a new folder with the number of the new tableanalyze.
                3. Create sub script.
                4. Create script to CLASSIFY on CHARACTER, DATE and LOGICAL fields and STRATIFY on NUMERIC fields.
                5. Split script in subscript (is used if here are more than 40 fields - group limitations).
                6. Make a table with the content in every field (CLASSIFY on CHARACTER, DATE and LOGICAL fields and STRATIFY on NUMERIC fields).
                6. Adjust Default_View to the content of the fields and fieldname.
END


COM -------------------------- Begin ------------------------------------------

SET SAFETY OFF
SET ECHO NONE

DO SCRIPT e_audit_DEL_GetACLandTableInfo
DO SCRIPT e_audit_GetACLandTableInfo
IF v_GetUserSetExactOnOff='ON' SET EXACT OFF

DELETE BATCH e_audit_TABLE_ANALYSIS OK

COMMENT --- BEGIN --- DELETE temp tabelname ----
DELETE TMP_FORMAT_500.fil OK
DELETE FORMAT TMP_FORMAT_500 OK

DELETE TMP_FORMAT_2000.fil OK
DELETE FORMAT TMP_FORMAT_2000 OK

COMMENT --- END --- DELETE temp tabelname ----

COMMENT -------------------------- Language - Begin ------------------------------------------

COMMENT ----- v_default_language og v_valid_characters ------
DO SCRIPT Func_v_GetLanguage


COMMENT ----- EN ----- English ----- Begin ---

IF v_default_language='EN' v_foldername_top       ='TABLE_ANALYSIS'

COM -------- It is an advantage to use 2 letters in abbreviation ----------
IF v_default_language='EN' v_foldername_abbrev    ='TA'


IF v_default_language='EN' v_dialog_01_title      ='%v_foldername%'

IF v_default_language='EN' v_dialog_01_line_01    ='INFORMATION ON THE SCRIPT TABLE ANALYSIS TO ANALYZE THE CONTENT OF THE TABLE FIELDS:'
IF v_default_language='EN' v_dialog_01_line_02    ='The script does CLASSIFY on character, date and logical fields and STRATIFY on numeric fields (not fieldname a, which is a reserved word).'
IF v_default_language='EN' v_dialog_01_line_03    ='All information from the table analysis is placed in the folder %v_foldername_top%.'
IF v_default_language='EN' v_dialog_01_line_04    ='In the folder %v_foldername_top% will be created a directory named %v_foldername_abbrev% + a sequential number + name of the table you choose. Example %v_foldername_top%/%v_foldername_abbrev%01_GENERAL_LEDGER.'
IF v_default_language='EN' v_dialog_01_line_05    ='In the folder %v_foldername_abbrev% + a sequential number + name of selected table (example %v_foldername_abbrev%01_GENERAL_LEDGER) will be created tables with field names. Example: %v_foldername_top% / %v_foldername_abbrev%01_GENERAL_LEDGER / TA01_Voucherno.'
IF v_default_language='EN' v_dialog_01_line_06    ='Example:'
IF v_default_language='EN' v_dialog_01_line_07    ='%v_foldername_top%'
IF v_default_language='EN' v_dialog_01_line_08    ='%v_foldername_abbrev%_GENERAL_LEDGER'
IF v_default_language='EN' v_dialog_01_line_09    ='%v_foldername_abbrev%01_Voucher %v_foldername_abbrev%01_Date %v_foldername_abbrev%01_Account %v_foldername_abbrev%01_Text'
IF v_default_language='EN' v_dialog_01_line_10    ='Choose table:'

COM --- Fieldnames for STRATIFY ----- Begin ---
IF v_default_language='EN' v_num_field_01         ='FIELDNAME'
IF v_default_language='EN' v_num_field_02         ='INTERVALS_FROM'
IF v_default_language='EN' v_num_field_022        ='INTERVALS_TO'
IF v_default_language='EN' v_num_field_03         ='COUNT'
IF v_default_language='EN' v_num_field_04         ='PERCENT_OF_COUNT'
IF v_default_language='EN' v_num_field_05         ='PERCENT_OF_VALUE'
IF v_default_language='EN' v_num_field_06         ='FIELD_VALUE'
COM --- Fieldnames for STRATIFY ----- End ---

IF v_default_language='EN' v_end_text             ='Table analysis done. See the folder:'

COMMENT ----- EN ----- English ----- End -----



COMMENT ----- DA ----- Danish --- Start ------

IF v_default_language='DA' v_foldername_top       ='TABEL_ANALYSE'

COM -------- Det er en fordel at bruge 2 bogstaver som forkortelse ----------
IF v_default_language='DA' v_foldername_abbrev    ='TA'

IF v_default_language='DA' v_dialog_01_title      ='%v_foldername_top%'+blanks(55)+'WWW.SKAT.DK'

IF v_default_language='DA' v_dialog_01_line_01    ='INFORMATION OM SCRIPTET TABELANALYSE DER ANALYSERER INDHOLDET I TABELLENS FELTER:'
IF v_default_language='DA' v_dialog_01_line_02    ='Scriptet laver CLASSIFY p karakter-, dato- og logiskefelter og STRATIFY p numeriske felter (ikke feltnavn a, som er et reserveret ord).'
IF v_default_language='DA' v_dialog_01_line_03    ='Alle oplysninger fra tabelanalysen bliver placeret i folderen %v_foldername_top%.'
IF v_default_language='DA' v_dialog_01_line_04    ='I folderen %v_foldername_top% bliver der oprettet en folder med navnet %v_foldername_abbrev% + et fortlbende nummer + navnet p den tabel man vlger. Eksempel: %v_foldername_top% / %v_foldername_abbrev%01_FINANS'
IF v_default_language='DA' v_dialog_01_line_05    ='I folderen %v_foldername_abbrev% + et fortlbende nummer + navnet p valgt tabel (eksempel %v_foldername_abbrev%01_FINANS), bliver der oprettet tabeller med feltnavne. Eksempel: %v_foldername_top% / %v_foldername_abbrev%01_FINANS / %v_foldername_abbrev%01_Bilagsnr'
IF v_default_language='DA' v_dialog_01_line_06    ='Eksempel:'
IF v_default_language='DA' v_dialog_01_line_07    ='%v_foldername_top%'
IF v_default_language='DA' v_dialog_01_line_08    ='%v_foldername_abbrev%_FINANS'
IF v_default_language='DA' v_dialog_01_line_09    ='%v_foldername_abbrev%01_Bilagsnr %v_foldername_abbrev%01_Dato %v_foldername_abbrev%01_Kontonr %v_foldername_abbrev%01_Tekst'
IF v_default_language='DA' v_dialog_01_line_10    ='Vlg tabel:'

IF v_default_language='DA' v_end_text             ='Tabel analysen er frdig. Se folderen:'

COM --- Fieldnames for STRATIFY ----- Begin ---
IF v_default_language='DA' v_num_field_01         ='FELTNAVN'
IF v_default_language='DA' v_num_field_02         ='INTERVAL_FRA'
IF v_default_language='DA' v_num_field_022        ='INTERVAL_TIL'
IF v_default_language='DA' v_num_field_03         ='ANTAL'
IF v_default_language='DA' v_num_field_04         ='PROCENT_AF_ANTAL'
IF v_default_language='DA' v_num_field_05         ='PROCENT_AF_VRDI'
IF v_default_language='DA' v_num_field_06         ='FELT_VRDI'
COM --- Fieldnames for STRATIFY ----- End ---

COMMENT ----- DA ----- Danish --- End --------



COMMENT -------------------------- Language - End --------------------------------------------
com DO e_audit_DEL_GetACLandTableInfo
com DO e_audit_GetACLandTableInfo

SET SAFETY OFF
SET ECHO NONE



COM -------------------------- Access to table name - Begin ------------------------------------------

DIR %v_foldername_abbrev%*.fil to w55_ta_antal
OPEN W55_ta_antal
COUNT if MAP(ALLTRIM(REVERSE(SPLIT(REVERSE(FILE_NAME) '\' 1))) '%v_foldername_abbrev%99_')
if COUNT1=0 v_ta_fornavn='%v_foldername_abbrev%01'

if COUNT1<>0 DEFINE FIELD ta_antal COMPUTED VALUE(SPLIT(ALLTRIM(REVERSE(SPLIT(REVERSE(FILE_NAME) '\' 1)))'_' 1) 0)
if COUNT1<>0 STATISTICS ON ta_antal
if COUNT1<>0 v_ta_fornavn='%v_foldername_abbrev%'+ZONED(MAX1+1 2))

CLOSE
DELETE w55_ta_antal.fil OK
DELETE FORMAT w55_ta_antal OK

COM -------------------------- Access to table name - End ------------------------------------------

DELETE w55_fields_cndl_s_end.bat OK

OPEN %v_GetOpenTableName%


COM --- BEGIN --- CREATE FOLDER ---
v_foldername = '%v_foldername_top%/%v_ta_fornavn%_'+ALLTRIM(SUBSTR('%v_GetOpenTableName%' 1 27))
SET FOLDER /%v_foldername%
COM --- END ----- CREATE FOLDER ---


COM --- BEGIN --- CREATE GROUP SCRIPT ----------------------------

v_number_of_fields=1

EXPORT "DELETE SCRIPT w55_fields_cndl_s_end OK" FIRST 1 to w55_fields_cndl.bat
EXPORT "GROUP" FIRST 1 to w55_fields_cndl.bat APPEND

COM --- BEGIN --- Numeric fields ----------------------------

IF v_GetNumberOfNumeric<>0 DELETE w55_tmp_stat_num.txt OK
IF v_GetNumberOfNumeric<>0 DELETE w55_tmp_stat_num.fil OK
IF v_GetNumberOfNumeric<>0 DELETE FORMAT w55_tmp_stat_num OK

IF v_GetNumberOfNumeric<>0 v_numeric_fields_space = ALLTRIM(REPLACE('%v_GetNumericFields%' '#' ' '))
IF v_GetNumberOfNumeric<>0 STATISTICS ON %v_numeric_fields_space% TO "w55_tmp_stat_num.TXT" NUMBER 1
IF v_GetNumberOfNumeric<>0 IMPORT PRINT TO w55_tmp_stat_num "w55_tmp_stat_num.FIL" FROM "w55_tmp_stat_num.TXT" 0 RECORD "Header1" 1 1 0 TEST 0 0 AT 1 3 0 7 "Field    :" FIELD "Fieldname_num" C AT 1 14 SIZE 31 1 DEC 0 WID 19  PIC "" AS "" RECORD "Detail" 0 2 0 TEST 0 0 AT 1 3 0 7 "Highest  :" FIELD "Highest" C AT 1 14 SIZE 31 1 DEC 0 WID 31  PIC "" AS "" FIELD "Lowest" C AT 2 14 SIZE 31 1 DEC 0 WID 31  PIC "" AS "" 

IF v_GetNumberOfNumeric<>0 DEFINE FIELD Numeric_line COMPUTED 'STRATIFY ON '+ALLTRIM(Fieldname_num)+' MINIMUM '+ALLTRIM(STRING(VALUE(Lowest 0)-1 20))+' MAXIMUM '+ALLTRIM(STRING(VALUE(Highest 0)+1 20))+' TO '+ALLTRIM(v_ta_fornavn)+'_'+ZONED(RECNO() 2)+'_'+ALLTRIM(SUBSTR(Fieldname_num 1 22))

IF v_GetNumberOfNumeric<>0 EXPORT ALLTRIM(Numeric_Line) TO w55_fields_cndl.bat APPEND


IF v_GetNumberOfNumeric<>0 DELETE w55_tmp_stat_num.txt OK
IF v_GetNumberOfNumeric<>0 DELETE w55_tmp_stat_num.fil OK
IF v_GetNumberOfNumeric<>0 DELETE FORMAT w55_tmp_stat_num OK

IF v_GetNumberOfNumeric<>0 v_number_of_fields=v_number_of_fields+v_GetNumberOfNumeric

COM --- End ----- Numeric fields ----------------------------


OPEN %v_GetOpenTableName%


COM --- BEGIN --- Character fields ----------------------------
IF v_GetNumberOfChar<>0 EXPORT "v_char_field=ALLTRIM(SPLIT(v_GetCharFields '#' v_count_sub_char))" FIRST 1 to w55_sub_char.bat 
IF v_GetNumberOfChar<>0 EXPORT "v_char_field_file=v_ta_fornavn+'_'+ZONED(v_number_of_fields 2)+'_'+ALLTRIM(SUBSTR(v_char_field 1 22))+'.fil'"  FIRST 1 to w55_sub_char.bat APPEND
IF v_GetNumberOfChar<>0 com EXPORT "EXPORT 'CLASSIFY ON ALLTRIM(SUBSTR(%"+v_char_field+"% 1 63)) AS "+chr(39)+"%"+v_char_field+"%"+chr(39)+" TO %"+v_char_field_file+"% "' FIRST 1 TO w55_fields_cndl.bat APPEND"  FIRST 1 to w55_sub_char.bat APPEND

IF v_GetNumberOfChar<>0 EXPORT "EXPORT 'CLASSIFY ON ALLTRIM(SUBSTR(' + v_char_field +' 1 63)) AS '+chr(39)+v_char_field+chr(39)+' TO '+v_char_field_file+' ' FIRST 1 TO w55_fields_cndl.bat APPEND"  FIRST 1 to w55_sub_char.bat APPEND


IF v_GetNumberOfChar<>0 EXPORT "v_count_sub_char=v_count_sub_char+1"  FIRST 1 to w55_sub_char.bat APPEND
IF v_GetNumberOfChar<>0 EXPORT "v_number_of_fields=v_number_of_fields+1"  FIRST 1 to w55_sub_char.bat APPEND

IF v_GetNumberOfChar<>0 v_count_sub_char=1

IF v_GetNumberOfChar<>0 DO SCRIPT w55_sub_char WHILE v_count_sub_char<=v_GetNumberOfChar

IF v_GetNumberOfChar<>0 DELETE v_count_sub_char OK
IF v_GetNumberOfChar<>0 DELETE SCRIPT w55_sub_char OK
IF v_GetNumberOfChar<>0 DELETE w55_sub_char.bat OK
IF v_GetNumberOfChar<>0 DELETE v_char_field_file OK
IF v_GetNumberOfChar<>0 DELETE v_char_field OK


COM --- END ----- Character fields ----------------------------

COM --- BEGIN --- Date fields ----------------------------

IF v_GetNumberOfDate<>0 EXPORT "v_date_field_name=ALLTRIM(SPLIT(v_GetDateFields '#' v_count_sub_date))" FIRST 1 to w55_sub_date.bat 
IF v_GetNumberOfDate<>0 EXPORT "v_date_field='DATE('+ALLTRIM(SPLIT(v_GetDateFields '#' v_count_sub_date))+')'" FIRST 1 to w55_sub_date.bat APPEND
IF v_GetNumberOfDate<>0 EXPORT "v_date_field_file=v_ta_fornavn+'_'+ZONED(v_number_of_fields 2)+'_'+ALLTRIM(SUBSTR(v_date_field_name 1 22))+'.fil'"  FIRST 1 to w55_sub_date.bat APPEND
IF v_GetNumberOfDate<>0 EXPORT "EXPORT 'CLASSIFY ON ' + v_date_field +' AS '+chr(34)+v_date_field_name+chr(34)+' TO '+v_date_field_file+' ' FIRST 1 TO w55_fields_cndl.bat APPEND"  FIRST 1 to w55_sub_date.bat APPEND
IF v_GetNumberOfDate<>0 EXPORT "v_count_sub_date=v_count_sub_date+1"  FIRST 1 to w55_sub_date.bat APPEND
IF v_GetNumberOfDate<>0 EXPORT "v_number_of_fields=v_number_of_fields+1"  FIRST 1 to w55_sub_date.bat APPEND

IF v_GetNumberOfDate<>0 v_count_sub_date=1

IF v_GetNumberOfDate<>0 DO SCRIPT w55_sub_date WHILE v_count_sub_date<=v_GetNumberOfDate

IF v_GetNumberOfDate<>0 DELETE v_count_sub_date OK
IF v_GetNumberOfDate<>0 DELETE SCRIPT w55_sub_date OK
IF v_GetNumberOfDate<>0 DELETE w55_sub_date.bat OK
IF v_GetNumberOfDate<>0 DELETE v_date_field_file OK
IF v_GetNumberOfDate<>0 DELETE v_date_field OK

COM --- END ----- Date fields ----------------------------


COM --- BEGIN --- Logic fields ----------------------------

IF v_GetNumberOfLogical<>0 v_tmp_logic_fields=' '
IF v_GetNumberOfLogical<>0 EXPORT "v_logic_field=ALLTRIM(SPLIT(v_GetLogicalFields '#' v_count_sub_logic))" FIRST 1 to w55_sub_logic.bat 
IF v_GetNumberOfLogical<>0 EXPORT "v_logic_field2=ALLTRIM(SUBSTR(ALLTRIM(SPLIT(v_GetLogicalFields '#' v_count_sub_logic)) 1 30))+'_'" FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT "DELETE FIELD %"+"v_logic_field2"+"% OK" FIRST 1 to w55_sub_logic.bat  APPEND

IF v_GetNumberOfLogical<>0 EXPORT "v_tmp_logic_fields=ALLTRIM('%"+"v_tmp_logic_fields"+"%')+ALLTRIM('%"+"v_logic_field2"+"%')+'#'" FIRST 1 to w55_sub_logic.bat  APPEND

IF v_GetNumberOfLogical<>0 EXPORT "DEFINE FIELD %"+"v_logic_field2"+"% COMPUTED" FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT " " FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT "'T' if %"+"v_logic_field"+"%=T" FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT "'F' if %"+"v_logic_field"+"%=F" FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT "''" FIRST 1 to w55_sub_logic.bat  APPEND
IF v_GetNumberOfLogical<>0 EXPORT "v_logic_field_file=v_ta_fornavn+'_'+ZONED(v_number_of_fields 2)+'_'+ALLTRIM(SUBSTR(v_logic_field 1 22))+'.fil'"  FIRST 1 to w55_sub_logic.bat APPEND
IF v_GetNumberOfLogical<>0 EXPORT "EXPORT "+chr(34)+"CLASSIFY ON %v_logic_field2%  AS "+chr(39)+ "%v_logic_field%" +chr(39)+"  TO %v_logic_field_file% "+chr(34)+" FIRST 1 TO w55_fields_cndl.bat APPEND"  FIRST 1 to w55_sub_logic.bat APPEND
IF v_GetNumberOfLogical<>0 EXPORT "v_count_sub_logic=v_count_sub_logic+1"  FIRST 1 to w55_sub_logic.bat APPEND
IF v_GetNumberOfLogical<>0 EXPORT "v_number_of_fields=v_number_of_fields+1"  FIRST 1 to w55_sub_logic.bat APPEND

IF v_GetNumberOfLogical<>0 v_count_sub_logic=1

IF v_GetNumberOfLogical<>0 DO SCRIPT w55_sub_logic WHILE v_count_sub_logic<=v_GetNumberOfLogical

IF v_GetNumberOfLogical<>0 DELETE v_count_sub_logic OK
IF v_GetNumberOfLogical<>0 DELETE SCRIPT w55_sub_logic OK
IF v_GetNumberOfLogical<>0 DELETE w55_sub_logic.bat OK
IF v_GetNumberOfLogical<>0 DELETE v_logic_field_file OK
IF v_GetNumberOfLogical<>0 DELETE v_logic_field2 OK
IF v_GetNumberOfLogical<>0 DELETE v_logic_field OK


COM --- END ----- Logic fields ----------------------------


EXPORT "END" FIRST 1 to w55_fields_cndl.bat APPEND

DELETE v_number_of_fields OK

COM --- END ----- CREATE GROUP SCRIPT ----------------------------


COM --- BEGIN ----- SPLIT GROUP SCRIPT ----------------------------

COMMENT --- BEGIN --- Make temporary format ----
DIR C:\w55.* TO TMP_C_DREV
OPEN TMP_C_DREV
DEFINE FIELD TMP_LINE COMPUTED BLANKS(500)
DEFINE FIELD tmp_line_ny COMPUTED BLANKS(2000)

EXTRACT TMP_LINE FIRST 1 to TMP_FORMAT_500
EXTRACT tmp_line_ny FIRST 1 to W55_FORMAT_2000
COMMENT --- END --- Make temporary format ----


COMMENT --- BEGIN --- OPEN SCRIPT AND SPLIT LINES AND MAKE A NEW SCRIPT ----

OPEN w55_fields_cndl.bat FORMAT TMP_FORMAT_500 CRLF

DEFINE FIELD new_line COMPUTED

TMP_LINE+CHR(10)+'END'+CHR(10)+CHR(10)+'GROUP' IF MOD( RECNO()  40)=0
TMP_LINE

EXPORT FIELD new_line TO w55_fields_cndl_s.bat ASCII
CLOSE

COMMENT --- END ----- OPEN SCRIPT AND SPLIT LINES AND MAKE A NEW SCRIPT ----


COMMENT --- BEGIN --- CHECK DOUBLE END IN SUBSCRIPT ---
OPEN w55_fields_cndl_s.bat FORMAT TMP_FORMAT_500 CRLF
COUNT
v_number_of_rec=COUNT1
COUNT IF ALLTRIM(TMP_LINE) ='END' AND RECOFFSET( ALLTRIM(TMP_LINE)  1)='END'
v_number_of_double_end=COUNT1
IF v_number_of_double_end=0 EXPORT FIELD TMP_LINE TO w55_fields_cndl_s_end.bat ASCII 
IF v_number_of_double_end=1 EXPORT FIELD TMP_LINE TO w55_fields_cndl_s_end.bat if RECNO()<=v_number_of_rec-3 ASCII 

DELETE v_number_of_rec OK
DELETE v_number_of_double_end OK
COMMENT --- END ----- CHECK DOUBLE END IN SUBSCRIPT ---


COMMENT --- BEGIN --- DELETE temp tabelname ----
OPEN TMP_C_DREV.fil FORMAT TMP_FORMAT_500 CRLF
CLOSE
DELETE FORMAT TMP_C_DREV OK
DELETE TMP_C_DREV.fil OK

COMMENT --- END --- DELETE temp tabelname ----



DELETE w55_fields_cndl.bat OK
DELETE w55_fields_cndl_s.bat OK

COM --- END ------- SPLIT GROUP SCRIPT ----------------------------



COM --- BEGIN ----- RUN GROUP SCRIPT ----------------------------
OPEN %v_GetOpenTableName%
DO SCRIPT w55_fields_cndl_s_end.bat

COM --- END ------- RUN GROUP SCRIPT ----------------------------

COM --- BEGIN ------- DELETE GROUP SCRIPT - MAIN SCRIPT ---------------------------
DELETE w55_fields_cndl_s_end.bat OK
COM --- END -__------ DELETE GROUP SCRIPT - MAIN SCRIPT ---------------------------


COM --- BEGIN ----- CREATE SUB SCRIPT ----------------------------

IF v_GetNumberOfNumeric<>0 EXPORT "LOCATE RECORD v_tmp_number_of_numeric" FIRST 1 TO w55_sub_numeric_fields.bat
IF v_GetNumberOfNumeric<>0 EXPORT "v_open_file=ALLTRIM(FILE_NAME)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "v_tmp_filnavn=ALLTRIM(tmp_filnavn)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "v_tmp_filnavn_txt=ALLTRIM(tmp_filnavn)+'.txt'" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "OPEN "+chr(34)+"%"+"v_open_file"+"%"+chr(34)+" FORMAT TMP_FORMAT_500 CRLF" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_fieldname OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_intervals_from OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_intervals_from_c OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_intervals_to OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_count OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_pct_of_number OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_field_value OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "DELETE FIELD tmp_pct_of_value OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND


IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_fieldname COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find('Count   <-- %') STATIC" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "ALLTRIM(SPLIT(substr(ALLTRIM(TMP_LINE) 1 31) ' ' 1))" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_intervals_from COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(ALLTRIM(SPLIT( TMP_LINE  '->'  1)) 2)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_intervals_from_c COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "SUBSTR(ALLTRIM(SPLIT(SPLIT(REPLACE(REPLACE(LTRIM(TMP_LINE) '  ' ' ') ' -> ' '->') ' ' 1) '->' 1)) 1 20)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_intervals_to COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(ALLTRIM(SPLIT(ALLTRIM(SPLIT( TMP_LINE  '->'  2)) ' ' 1)) 2)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_count COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(SUBSTR(REVERSE(ALLTRIM(SPLIT(ALLTRIM(REVERSE(SPLIT(TMP_LINE Alltrim(reverse(split(alltrim(reverse(alltrim(split(TMP_LINE '%' 1)))) ' ' 1)))+'%' 1))) ' ' 1))) 1 15) 0)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
COM IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(SUBSTR(ALLTRIM(SPLIT(ALLTRIM(SPLIT(TMP_LINE ALLTRIM(SPLIT(ALLTRIM(SPLIT( TMP_LINE  '->'  2 )) ' ' 1)) 2)) ' ' 1)) 1 15) 0)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_pct_of_number COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(SUBSTR(REVERSE(ALLTRIM(SPLIT(ALLTRIM(REVERSE(SPLIT(TMP_LINE '%' 1))) ' ' 1)))1 8) 2)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_field_value COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(SUBSTR(ALLTRIM(SPLIT( TMP_LINE  '%'  2)) 1 8) 2)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DEFINE FIELD tmp_pct_of_value COMPUTED " FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "IF find(' -> ')" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "VALUE(SUBSTR(REVERSE(SPLIT(REVERSE(ALLTRIM( TMP_LINE)) ' ' 1)) 1 25) 2)" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "EXTRACT FIELDS tmp_fieldname AS '%"+"v_num_field_01"+"%' tmp_intervals_from AS '%"+"v_num_field_02"+"%'  tmp_intervals_to AS '%"+"v_num_field_022"+"%' tmp_count AS '%"+"v_num_field_03"+"%' tmp_pct_of_number AS '%"+"v_num_field_04"+"%' tmp_field_value AS '%"+"v_num_field_05"+"%' tmp_pct_of_value AS '%"+"v_num_field_06"+"%' IF NOT ISBLANK(tmp_intervals_from_c) TO %"+"v_tmp_filnavn"+"%" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "v_tmp_number_of_numeric=v_tmp_number_of_numeric-1" FIRST 1 TO w55_sub_numeric_fields.bat APPEND
IF v_GetNumberOfNumeric<>0 EXPORT "OPEN %"+"v_ta_fornavn"+"%_TMP_NUM" FIRST 1 TO w55_sub_numeric_fields.bat APPEND

IF v_GetNumberOfNumeric<>0 EXPORT "DELETE %"+"v_tmp_filnavn_txt"+"% OK" FIRST 1 TO w55_sub_numeric_fields.bat APPEND


COM --- END ------- CREATE SUB SCRIPT ----------------------------




IF v_GetNumberOfNumeric<>0 DIR %v_ta_fornavn%*.txt TO %v_ta_fornavn%_TMP_NUM
IF v_GetNumberOfNumeric<>0 OPEN %v_ta_fornavn%_TMP_NUM
IF v_GetNumberOfNumeric<>0 v_tmp_number_of_numeric=WRITE1

IF v_GetNumberOfNumeric<>0 DEFINE FIELD tmp_filnavn COMPUTED SUBSTR(ALLTRIM(SPLIT(SUBSTR(ALLTRIM(REVERSE(SPLIT(ALLTRIM(REVERSE( FILE_NAME)) '\' 1))) 1 35) '.TXT' 1)) 1 31)

IF v_GetNumberOfNumeric<>0 DO SCRIPT w55_sub_numeric_fields.bat WHILE v_tmp_number_of_numeric>0



IF v_GetNumberOfNumeric<>0 DELETE SCRIPT w55_sub_numeric_fields OK
IF v_GetNumberOfNumeric<>0 DELETE w55_sub_numeric_fields.bat OK

CLOSE

DELETE %v_ta_fornavn%_TMP_NUM.FIL OK
DELETE FORMAT %v_ta_fornavn%_TMP_NUM OK


COMMENT --- BEGIN --- DELETE temp tabelname ----
DELETE TMP_FORMAT_500.fil OK
DELETE FORMAT TMP_FORMAT_500 OK

COMMENT --- END --- DELETE temp tabelname ----










COM ------------- Customize default view in new tables ----- Begin ---------


DELETE BATCH w55_ta_fjern_kolonner OK
DELETE w55_ta_fjern_kolonner.bat OK

DIR %v_ta_fornavn%*.fil to w55_ta_filer
OPEN w55_ta_filer


COM --- SUBSCRIPT --- w55_ta_fjern_kolonner --- Begin ------

EXPORT "v_feltnavn=Alltrim(REPLACE(ALLTRIM(SPLIT(v_felter chr(9) v_antal)) chr(34) ''))" FIRST 1 TO w55_ta_fjern_kolonner.bat 
EXPORT "DELETE COLUMN Default_View %"+"v_feltnavn"+"% ALL OK" FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'if FTYPE("%'+'v_feltnavn'+'%")="C" STATISTICS LENGTH(ALLTRIM(%'+'v_feltnavn'+'%))' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'if FTYPE("%'+'v_feltnavn'+'%")="N" STATISTICS LENGTH(ALLTRIM(STRING(%'+'v_feltnavn'+'% 20)))' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'if FTYPE("%'+'v_feltnavn'+'%")="D" STATISTICS LENGTH(ALLTRIM(DATE(%'+'v_feltnavn'+'%)))' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'v_length_feltnavn=LENGTH(ALLTRIM("%'+'v_feltnavn'+'%"))' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'if v_length_feltnavn>%'+'MAX1'+'% MAX1=%'+'v_length_feltnavn'+'%' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'DEFINE COLUMN Default_View %'+'v_feltnavn'+'% WIDTH %'+'MAX1'+'% POSITION %'+'v_antal'+'%' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'SAVE' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'DELETE v_length_feltnavn OK' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND
EXPORT 'v_antal=v_antal+1' FIRST 1 TO w55_ta_fjern_kolonner.bat APPEND

COM --- SUBSCRIPT --- w55_ta_fjern_kolonner --- End --------



COM --- SUBSCRIPT --- w55_ta_tilpas_view --- Begin --------

EXPORT 'LOCATE RECORD %'+'v_antal_ta_filer_count'+'%' FIRST 1 to w55_ta_tilpas_view.bat 
EXPORT "v_ta_filnavn=ALLTRIM(SPLIT(REVERSE(ALLTRIM(SPLIT(Alltrim(REVERSE(FILE_NAME)) '\' 1))) '.FIL' 1))"  FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'OPEN %'+'v_ta_filnavn'+'%'  FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT "EXPORT FIELDS ALL DELIMITED TO 'w55_exp_view_felter.del' IF RECNO( ) = 0 KEEPTITLE SEPARATOR TAB QUALIFIER '"+chr(34)+"'" FIRST 1 to w55_ta_tilpas_view.bat  APPEND
 
EXPORT 'OPEN w55_exp_view_felter.del FORMAT W55_FORMAT_2000 CRLF ' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'v_felter=Alltrim(tmp_line_ny)' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'v_antal_felter=OCCURS(v_felter chr(9))+1' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'OPEN %'+'v_ta_filnavn'+'%' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'v_antal=1' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DEFINE VIEW Default_View OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DO w55_ta_fjern_kolonner while v_antal<=v_antal_felter' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'DELETE w55_exp_view_felter.del OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'DELETE v_felter OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DELETE v_antal_felter OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DELETE v_antal OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DELETE v_feltnavn OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'DELETE v_ta_filnavn OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'COM DELETE BATCH w55_ta_fjern_kolonner OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'COM DELETE w55_ta_fjern_kolonner.bat OK' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

EXPORT 'v_antal_ta_filer_count=v_antal_ta_filer_count+1' FIRST 1 to w55_ta_tilpas_view.bat  APPEND
EXPORT 'OPEN w55_ta_filer' FIRST 1 to w55_ta_tilpas_view.bat  APPEND

COM --- SUBSCRIPT --- w55_ta_tilpas_view --- End ----------




COUNT
v_antal_ta_filer=COUNT1
v_antal_ta_filer_count=1

DO w55_ta_tilpas_view while v_antal_ta_filer_count<=v_antal_ta_filer

DELETE W55_FORMAT_2000.FIL OK
DELETE FORMAT  W55_FORMAT_2000 OK

DELETE v_antal_ta_filer OK
DELETE v_antal_ta_filer_count OK

DELETE FORMAT w55_ta_filer OK
DELETE w55_ta_filer.fil OK


DELETE BATCH w55_ta_fjern_kolonner OK
DELETE w55_ta_fjern_kolonner.bat OK

DELETE BATCH w55_ta_tilpas_view OK
DELETE w55_ta_tilpas_view.bat OK

DELETE w55_tmp_felter.del OK

COM ------------- Customize default view in new tables ----- End ---------

OPEN %v_GetOpenTableName%


PAUSE "%v_end_text%"+chr(10)+chr(13)+chr(10)+chr(13)+"%v_foldername_top%\%v_ta_fornavn%_%v_GetOpenTableName%"


COM --- BEGIN --- DELETE TMP LOGICAL FIELDS ------------------------------

IF v_GetNumberOfLogical<>0 EXPORT "v_tmp_delete_field_l=ALLTRIM(SPLIT(v_tmp_logic_fields '#' v_count_tmp_logical_sub))" FIRST 1 TO w55_sub_logical_delete.bat
IF v_GetNumberOfLogical<>0 EXPORT "DELETE FIELD %v_tmp_delete_field_l% OK" FIRST 1 TO w55_sub_logical_delete.bat APPEND
IF v_GetNumberOfLogical<>0 EXPORT "v_count_tmp_logical_sub=v_count_tmp_logical_sub+1"  FIRST 1 TO w55_sub_logical_delete.bat APPEND

IF v_GetNumberOfLogical<>0 v_count_tmp_logical = OCCURS(v_tmp_logic_fields '#')

IF v_GetNumberOfLogical<>0 v_count_tmp_logical_sub=1

IF v_GetNumberOfLogical<>0 DO SCRIPT w55_sub_logical_delete.bat WHILE v_count_tmp_logical_sub<=v_count_tmp_logical

IF v_GetNumberOfLogical<>0 DELETE v_tmp_delete_field_l OK
IF v_GetNumberOfLogical<>0 DELETE v_count_tmp_logical_sub OK
IF v_GetNumberOfLogical<>0 DELETE v_count_tmp_logical OK
IF v_GetNumberOfLogical<>0 DELETE v_tmp_logic_fields OK

IF v_GetNumberOfLogical<>0 DELETE SCRIPT w55_sub_logical_delete OK
IF v_GetNumberOfLogical<>0 DELETE w55_sub_logical_delete.bat OK

COM --- END ----- DELETE TMP LOGICAL FIELDS ------------------------------
SET EXACT %v_GetUserSetExactOnOff%
DO SCRIPT e_audit_GetACLandTableInfo

SET SAFETY OFF
SET ECHO NONE



DELETE v_foldername_top OK
DELETE v_foldername_abbrev OK
DELETE v_dialog_01_title OK
DELETE v_dialog_01_line_01 OK
DELETE v_dialog_01_line_02 OK
DELETE v_dialog_01_line_03 OK
DELETE v_dialog_01_line_04 OK
DELETE v_dialog_01_line_05 OK
DELETE v_dialog_01_line_06 OK
DELETE v_dialog_01_line_07 OK
DELETE v_dialog_01_line_08 OK
DELETE v_dialog_01_line_09 OK
DELETE v_dialog_01_line_10 OK
DELETE v_end_text OK
DELETE v_num_field_01 OK
DELETE v_num_field_02 OK
DELETE v_num_field_022 OK
DELETE v_num_field_03 OK
DELETE v_num_field_04 OK
DELETE v_num_field_05 OK
DELETE v_num_field_06 OK
DELETE v_ta_fornavn OK
DELETE v_foldername OK
DELETE v_numeric_fields_space OK
DELETE v_date_field_name OK
DELETE v_open_file OK
DELETE v_tmp_filnavn OK
DELETE v_tmp_filnavn_txt OK
DELETE v_tmp_number_of_numeric OK

DELETE w55_tmp_stat_num.fil OK
DELETE W55_tmp_log.log OK
DELETE ext_w55_tmp_fieldnames.fil OK


DELETE v_valid_characters OK
DELETE v_default_language OK

SET FOLDER /

SET SAFETY ON
SET ECHO ON
