****************************** GENERAL INFORMATION OM SCRIPTET *********************************
*
COMMENT
COMMENT
COMMENT
****************************** GENERAL INFORMATION OM SCRIPTET *********************************
*
 Description:   The script create a new view where the fields are placed vertically.. 
*
 Version:       ACL version 9.3.
*
 Purpose:       The purpose of the script is:
                - get make it easy to make a report, when there are a lot of fields.
*
 Preconditions: A table with a view.
*
 Input:         None
*
 Output:        A new view with a V infront of the original view name.
*
*
 Date:          Developed: 2012-11-20
                Updated  : 2012-11-21 Version 1.0 -  Tested
*
 Version:       1.0
*
 Developer:     Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:     The script is made to help users of ACL in the Danish Tax Administration.
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
END


COMMENT 
*********** DANISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
 Beskrivelse:   Scriptet opretter et nyt view hvor felterne bliver placeret lodret.
*
 Version: ACL version 9.3.
*
 Forml:        Forml med scriptet er:
                - gre det lettere at lave en rapport, hvor der er mange felter.
*
 Forudstning:  En tabel med et view
*
 Input:         Ingen
*
 Output:        Et nyt view med et V foran navnet p det originale view.
*
*
 Applications:  Scriptet er placeret under 10 - Diverse
*
 Dato:          Udviklet:  2012-11-20
                Opdateret: 2012-11-21 Version 1.0 -  Testet
*
 Version:       1.0
*
 Udviklet af:   Arbejdsgruppe: Scripts og makroer
                Kontaktperson: Erling T Petersen, W00055. Email: erling.petersen@skat.dk
*
 Copyright:     Det er tilladt at kopiere hele eller dele scriptet, hvis du sender en email til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligtst en e-mail til erling.petersen@skat.dk, hvis du bruger scriptet, eller har
                forbedringsforslag. Det er rart at vide, om de script man laver, bliver brugt.
*
END





COM -------------------------- Start ------------------------------------------
SET ECHO NONE
SET SAFETY ON

DELETE SCRIPT e_audit_VIEW_VERTICAL OK

DO SCRIPT e_audit_GetACLandTableInfo

SET EXACT OFF

COMMENT -------------------------- Language - Begin --------------------------------------------
COM ----- DANISH --- Begin --------------------------------------------------------------------
IF v_default_language='DA' v_overview_fieldname='OVERSIGT_FELTNAVN'
IF v_default_language='DA' v_overview_fieldcontent='OVERSIGT_FELTINDHOLD'

IF v_default_language='DA' v_pause_text='Lodret view oprettet.'
COM ----- DANISH --- End ----------------------------------------------------------------------

COM ----- ENGLISH --- Begin -------------------------------------------------------------------
IF v_default_language='EN' v_overview_fieldname='OVERVIEW_FIELDNAME'
IF v_default_language='EN' v_overview_fieldcontent='OVERVIEW_FIELDCONTENT'

IF v_default_language='EN' v_pause_text='Vertical view created.'
COM ----- ENGLISH --- End --------------------------------------------------------------------
COMMENT -------------------------- Language - End ----------------------------------------------

SET FILTER



COM ----- BEGIN ----- Find max width in view -----------------------------------------------
GROUP FIRST 1
v_count_view_number=1
v_max_width=0
v_ViewFieldNumber_width=0
  LOOP WHILE v_count_view_number<=v_GetNumberOfFields
    v_ViewFieldNumber_width=LENGTH(ALLTRIM(SPLIT(v_GetFieldContentOfFirstRecord '#' v_count_view_number)))
    v_max_width=v_ViewFieldNumber_width IF v_max_width<v_ViewFieldNumber_width
    v_count_view_number=v_count_view_number+1
  END
END
DELETE v_count_view_number OK
DELETE v_ViewFieldNumber_width OK
if v_max_width>55 v_max_width=55
if v_max_width<20 v_max_width=20
COM ----- END ------- Find max width in view -----------------------------------------------


COM ----- BEGIN ----- Create new view and fieldnames -----------------------------------------------
v_new_view_name=ALLTRIM(SUBSTR('V_'+v_GetOpenViewName 1 31))
DELETE COLUMN V_Default_View ALL OK
DELETE FIELD %v_overview_fieldname% OK
DELETE FIELD %v_overview_fieldcontent%  OK
com DEFINE FIELD %v_overview_fieldname%  COMPUTED '%v_overview_fieldname_c%'
DEFINE FIELD %v_overview_fieldname%  COMPUTED ' '
DEFINE FIELD %v_overview_fieldcontent% COMPUTED ' '
COM ----- END ------- Create new view and fieldnames -----------------------------------------------


COM ----- BEGIN ----- Create subscript w55_sub_div_view_vertical -----------------------------------------------
v_define_field=BLANKS(31)
v_define_first_column=BLANKS(200)
v_define_second_column=BLANKS(200)

GROUP FIRST 1
v_count_view_number=1
v_define_field=''
v_define_first_column=''
v_define_second_column=''
EXPORT 'DELETE SCRIPT w55_sub_div_view_vertical OK' ASCII TO w55_sub_div_view_vertical.bat
EXPORT 'DEFINE VIEW '+'%v_new_view_name%'+' OK' ASCII TO w55_sub_div_view_vertical.bat
EXPORT 'DEFINE COLUMN '+'%v_new_view_name%'+' %v_overview_fieldname% AS "%v_overview_fieldname%" POSITION 1 WIDTH 32' ASCII TO w55_sub_div_view_vertical.bat
EXPORT 'DEFINE COLUMN '+'%v_new_view_name%'+' %v_overview_fieldcontent% AS "%v_overview_fieldcontent%" POSITION 2 WIDTH '+STRING(v_max_width 2)+' ' ASCII TO w55_sub_div_view_vertical.bat
  LOOP WHILE v_count_view_number<=v_GetOpenViewFieldNumber
    EXPORT 'DELETE FIELD '+ALLTRIM(REPLACE(SUBSTR(SPLIT(v_GetOpenViewFieldName '#' v_count_view_number) 1 29) '.' '_'))+'_v OK' ASCII TO w55_sub_div_view_vertical.bat
    EXPORT 'DEFINE FIELD '+ALLTRIM(REPLACE(SUBSTR(SPLIT(v_GetOpenViewFieldName '#' v_count_view_number) 1 29) '.' '_'))+'_v '+'COMPUTED "'+SPLIT(v_GetOpenViewFieldName '#' v_count_view_number)+':"' ASCII TO w55_sub_div_view_vertical.bat
    EXPORT 'DEFINE COLUMN '+'%v_new_view_name%'+' '+ALLTRIM(REPLACE(SUBSTR(SPLIT(v_GetOpenViewFieldName '#' v_count_view_number) 1 29) '.' '_'))+'_v'+' POSITION 1 WIDTH 32 LINE '+STRING(v_count_view_number+1 2)+' ' ASCII TO w55_sub_div_view_vertical.bat
    EXPORT 'DEFINE COLUMN '+'%v_new_view_name%'+' '+SPLIT(v_GetOpenViewFieldName '#' v_count_view_number)+' POSITION 2 WIDTH '+STRING(v_max_width 2)+' LINE '+STRING(v_count_view_number+1 2)+' ' ASCII TO w55_sub_div_view_vertical.bat
    v_count_view_number=v_count_view_number+1
  END
END
DELETE v_count_view_number OK
DELETE v_define_field OK
DELETE v_define_first_column OK
DELETE v_define_second_column OK
DELETE v_new_view_name OK
DELETE v_max_width OK
COM ----- END ------- Create subscript w55_sub_div_view_vertical -----------------------------------------------


COM ----- BEGIN ----- Run subscript w55_sub_div_view_vertical -----------------------------------------------
DO SCRIPT w55_sub_div_view_vertical
COM ----- END ------- Run subscript w55_sub_div_view_vertical -----------------------------------------------

PAUSE "%v_pause_text%"

COM ----- BEGIN ----- Remove tmp variables -----------------------------------------------
DELETE v_overview_fieldname OK
DELETE v_overview_fieldcontent OK
DELETE v_pause_text OK
COM ----- END ------- Remove tmp variables -----------------------------------------------


COM ----- BEGIN ----- Return settings and filter -----------------------------------------------
SET FILTER %v_GetViewFilter%
SET EXACT %v_GetUserSetExactOnOff%
COM ----- END ------- Return settings and filter -----------------------------------------------


COM ----- BEGIN ----- Remove tmp variables -----------------------------------------------
DO SCRIPT e_audit_DEL_GetACLandTableInfo

DELETE w55_sub_div_view_vertical.bat OK
COM ----- END ------- Remove tmp variables -----------------------------------------------

