*** BEGIN Comments
*********** DANISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
COMMENT
COMMENT
COMMENT 
*** BEGIN Comments
*********** DANISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
 Description:   Scriptet laver et script, som bliver brugt af andre script til at bestemme hvilket sprog
                der skal vre i dialogboksene - engelsk eller dansk. 
*
 Version:       ACL version 9.2.1.
*
 Forml:        Formlet med scriptet:
                - gre det nemt at skifte mellem engelsk og dansk.
*
 Forudstning:  Engelsk version af ACL.
*
 Input:         Skrm dialog.
                - Vlg sprog.
*
 Output:        Opretter scriptet Func_v_GetLanguage.bat. Scriptet bliver brugt af andre script til at bestemme om teksten i dialogbokse
                skal vre p dansk eller engelsk.
*
*
 Date:          Udviklet:  2011-09-10
                Opdateret: 2011-09-10 Version 1.0
*
 Version:       1.0
*
 Udvikler:      Kontakt person: Erling T Petersen, Skattecenter Maribo, erling.petersen@skat.dk
*
 Copyright:     Scriptet er lavet for at hjlpe danske ACL brugere til at forklare scriptene til andre EU medlemmer (FISCALIS mv.)
                Det er tilladt at kopiere scriptet eller dele af scriptet, hvis du sender en mail til 
                erling.petersen@skat.dk. Det er gratis.
                Send venligst en mail til erling.petersen@skat.dk hvis du bruger scriptet eller har forslag til forbedringer.
                Det er rart at vide, om scriptet bliver brugt.
*
*********** ENGLISH ********************* GENEREL INFORMATION OM SCRIPTET ********************************
*
 Description:   The script makes a script which is used by other scripts to decide which language should be 
                used in dialogboxes - English or Danish.
*
 Version:       ACL version 9.2.1.
*
 Purpose:       The purpose of the script is:
                - make it easy to choose between Danish and English when using the Danish scripts.
*
 Preconditions: English version of ACL.
*
 Input:         Choose language.
*
 Output:        A script called Func_v_GetLanguage.bat. 
                Other Danish scripts call the script Func_v_GetLanguage.bat. The script deside which language other script shall use.
*
 Date:          Developed: 2011-09-10
                Updated  : 2011-09-10 Version 1.0
*
 Version:       1.0
*
 Developer:     Contact person: Erling T Petersen, Denmark, erling.petersen@skat.dk
*
 Copyright:     The script is made to help Danish ACL users explain the scripts to other EU members (FISCALIS visists etc.).
                It is permissible to copy all or parts of the script, if you send an email to 
                erling.petersen@skat.dk. It's free.
                Please send an email to erling.petersen@skat.dk if you use the script, or have 
                suggestions for improvement. 
                It's nice to know if the script is being used.
*
**************************************************************************************************************************
*** END Comments
END

DELETE SCRIPT E_AUDIT_DK_LANGUAGE OK
DELETE Func_v_GetLanguage.bat OK

COMMENT --- Begin --- Create temporary log and display ----
SET LOG TO w55_tmp_log
SET ECHO ON
Display
SET ECHO NONE
SET LOG OFF
COMMENT --- End --- Create temporary log and display ----


COMMENT --- Begin --- Make temporary format ----

DIR C:\w55.* TO TMP_C_DREV
OPEN TMP_C_DREV
DEFINE FIELD TMP_LINE COMPUTED BLANKS(1991)
EXTRACT TMP_LINE FIRST 1 to TMP_FORMAT_1991
COMMENT --- End --- Make temporary format ----

OPEN w55_tmp_log.log FORMAT TMP_FORMAT_1991 CRLF

COMMENT --- Begin --- Get open tabelname ----

LOCATE IF FIND('is your primary file.')
v_GetOpenTableName=ALLTRIM(REPLACE(ALLTRIM(SPLIT(ALLTRIM(SPLIT(TMP_LINE '(format ' 2)) ')' 1)) ' ' '_'))

COMMENT --- End --- Get open tabelname ----



COMMENT --- Begin ----------------------- Get tablename from user - Dialog boxes ------------------------------------------

if ISBLANK(v_GetOpenTableName) DIR c:\*.* TO w55_tmp_dir
if ISBLANK(v_GetOpenTableName) OPEN w55_tmp_dir
if NOT ISBLANK(v_GetOpenTableName) OPEN %v_GetOpenTableName%

COMMENT --- End ------------------------- Get tablename from user - Dialog boxes ------------------------------------------



DIALOG (DIALOG TITLE "SPROG / LANGUAGE" WIDTH 456 HEIGHT 233 ) (BUTTONSET TITLE "&OK;&Cancel" AT 360 72 DEFAULT 1 ) (TEXT TITLE "Vlg sprog / Choose language:" AT 24 76 WIDTH 186 HEIGHT 19 ) (DROPDOWN TITLE "DA;EN" TO "v_language" AT 228 72 ) (TEXT TITLE "Officielle sprog koder / Official language codes:" AT 24 16 ) (TEXT TITLE "BG,CS,DA,DE,ET,EL,EN,ES,FR,IT,LV,LT,GA,HU,MT,NL,PL,PT,RO,SK,SL,FI,SV" AT 24 40 WIDTH 420 )

EXPORT "SET SAFETY OFF" FIRST 1 to Func_v_GetLanguage.bat
EXPORT "SET ECHO NONE" FIRST 1 to Func_v_GetLanguage.bat APPEND

EXPORT "DELETE SCRIPT Func_V_GetLanguage OK" FIRST 1 to Func_v_GetLanguage.bat APPEND

EXPORT "v_default_language='%v_language%'" FIRST 1 to Func_v_GetLanguage.bat APPEND

IF v_language='DA' EXPORT "v_valid_characters = ' _1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'" FIRST 1 to Func_v_GetLanguage.bat APPEND
IF v_language='EN' EXPORT "v_valid_characters = ' _1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'" FIRST 1 to Func_v_GetLanguage.bat APPEND

EXPORT "SET ECHO ON" FIRST 1 to Func_v_GetLanguage.bat APPEND
EXPORT "SET SAFETY ON" FIRST 1 to Func_v_GetLanguage.bat APPEND

DELETE v_language OK
DELETE v_default_language OK
DELETE v_valid_characters OK

DO SCRIPT Func_v_GetLanguage

if ISBLANK(v_GetOpenTableName) CLOSE

DELETE FORMAT w55_tmp_dir OK
DELETE w55_tmp_dir OK

CLOSE
OPEN TMP_FORMAT_1991 FORMAT TMP_FORMAT_1991 CRLF
CLOSE

DELETE TMP_FORMAT_1991.fil OK
DELETE FORMAT TMP_FORMAT_1991 OK

DELETE TMP_C_DREV.fil OK
DELETE FORMAT TMP_C_DREV OK

DELETE w55_tmp_log.log OK

SET ECHO ON
SET SAFETY ON
